--drop table esss_2017_head
--go
if not exists (select * from sysobjects where name='pers_ess')
begin
	create table pers_ess (
		keyid int not null identity (1,1) PRIMARY KEY ,
		key_ess varchar(15) null,
		pers_id varchar(15) not null,
		nom_korr smallint not null,
		period varchar(2) not null,
		year_ smallint not null,
		nomer integer null,
		data_ datetime not null,

		sex char (1) not null,
		prizn_oms char (1) null,
		snils char (14) not null,
		prizn_ops char (1) null,
		grajd varchar (3) not null,
		kod_vid_doc varchar(2) not null,
		inn_fl varchar(12) not null,
		ser_nom_doc varchar (25) not null,
		prizn_occ char (1) not null,
		dt_r datetime not null,

		name varchar (60) not null,
		first_name varchar (60) not null,
		sec_name varchar (60) null,

		cv_viplopc decimal (16,2) null,
		cv_kkl varchar(4) null,
		cv_viplopcd decimal (16,2) null,
		cv_nachcv decimal (16,2) null,
		cv_mm varchar(2) null,
		cv_sumvipl decimal (16,2) null,
		
		mm tinyint null,
		n_sc_soc integer null,
		summa_oblag_tgp decimal(16,4) null,
		tgp_summa_nalog decimal(16,4) null,
		summa_oblag_td decimal(16,4) null,
		summa_nalog decimal(16,4) null,
		sum_tgp decimal(16,4) null,
		sum_td decimal(16,4) null,
		tgp_summa_nalog_n decimal(16,4) null,
		sum_dop1_tgp decimal(16,4) null,
		sum_dop2_tgp decimal(16,4) null,
		summa_nalog_n decimal(16,4) null,
		sum_dop1_td decimal(16,4) null,
		sum_dop2_td decimal(16,4) null,
		tabel_n varchar(32) null
	)
end
go
grant insert, select, update,delete on pers_ess to AitUsers
go


if not exists (select * from sysobjects where name='pers_ess_lgot')
begin
	create table pers_ess_lgot (
		keyid int not null identity (1,1) PRIMARY KEY ,
		key_ess varchar(15) null,
		pers_id varchar(15) null,
		vcvd_viplcv decimal (16,2) null,
		vcvd_nachcv decimal (16,2) null,
		vcvd_mm varchar(2) null,
		vcvd_tarif varchar(2) null
	)
end
go
grant insert, select, update,delete on pers_ess_lgot to AitUsers
go
if not exists(select 1 from sysobjects where name='esss_2017_head')
  create table esss_2017_head(
     key_f varchar(15) not null,--
     kod_ul varchar(15) not null,--

     --
     name_pred varchar(255) null,
     inn varchar(15) null,
     kpp varchar(9) null,
     oktmo varchar(15) null,
     yy smallint null,--
     otch_per char(2) null,--
     end_mm tinyint null,
     n_korr tinyint null,--
     kod_no char(4) null,
     po_mestu char(3) null,
     reorg char(1) null,--
     inn_reorg varchar(15) null,
     kpp_reorg varchar(9) null,
     okved varchar(8) null,--
     tlf varchar(100) null,
     pr_podp char(1) null,
     fam_podp varchar(50) null,
     im_podp varchar(50) null,
     ot_podp varchar(50) null,
     n_str smallint null,
     n_pril smallint null,
     date_ datetime null,--
     name_predst varchar(100) null,--
     dok_predst varchar(100) null,--
     kod_tarifa char(2) null,
     prizn_vipl_fss char(1) null,
     fl_ppu char(1) null,
     osn_sp1 tinyint null,-- .    2.4 
     osn_sp2 tinyint null,--  1  2 
     n_file varchar(36) null,

     primary key(key_f) 
  )
go
grant insert, select, update,delete on esss_2017_head to AitUsers
go
if not exists(select 1 from sysobjects where name='esss_2017_sums')
  create table esss_2017_sums(
     key_head varchar(15) not null,
     kod_tarif varchar(3) not null,
     kbk varchar(21) null,
     kod_str char(3) not null,
     razdel varchar(5) not null,
     vsego_rp decimal(16,2) null,
     vsego decimal(16,2) null,
     mm1 decimal(16,2) null,     
     mm2 decimal(16,2) null,     
     mm3 decimal(16,2) null,

     primary key(key_head, kod_tarif, kod_str, razdel)
  )
go
grant insert, select, update,delete on esss_2017_sums to AitUsers
go


if not exists(select 1 from sysobjects where name='esss_2017_fss')
  create table esss_2017_fss(
     key_head varchar(15) not null,
     razdel varchar(5) not null,
     kod_str char(3) not null,
     n_sl int null,
     days int null,
     rashod decimal(16,2) null,
     rashod_fb decimal(16,2) null,

     primary key(key_head, razdel, kod_str)
  )
go
grant insert, select, update,delete on esss_2017_fss to AitUsers
go

if not exists(select 1 from sysobjects where name='esss_inostr')
  create table esss_inostr(
     key_head varchar(15) not null,
     pers_id varchar(15) not null,
     l_name varchar(40) null,
     f_name varchar(40) null,
     s_name varchar(40) null,
     inn varchar(14) null,
     snils varchar(14) null,
     gragd char(3) null,
     vsego_rp decimal(16,2) null,
     vsego decimal(16,2) null,
     mm1 decimal(16,2) null,     
     mm2 decimal(16,2) null,     
     mm3 decimal(16,2) null,

     primary key(key_head, pers_id)
  )
go
grant insert, select, update,delete on esss_inostr to AitUsers
go

if not exists(select 1 from syscolumns where id = object_id('esss_2017_head') and name = 'date_reestr_r5')
begin
   alter table esss_2017_head add date_reestr_r5 datetime null
end
go
if not exists(select 1 from syscolumns where id = object_id('esss_2017_head') and name = 'num_reestr_r5')
begin
   alter table esss_2017_head add num_reestr_r5 varchar(20) null
end
go


IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.sp_pers_ess') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.sp_pers_ess
go

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE procedure dbo.sp_pers_ess
		@key_ess varchar(15), -- 
                @key_pbpers varchar(15) -- 
	 AS

	-- .
	--declare @id_u int,	@mm1 int, @mm2 int, @yy int, @gs_filial varchar(15), @key_ess varchar(15), @nom_korr int, @period varchar(2)
	--select @mm1 = 1, @mm2 = 3, @yy = 2015, @gs_filial = '1', @key_ess = 'hz', @nom_korr = 1, @period = '01'
	
	declare @max_baza decimal(16,2), @erase_all int
	declare @prizn_ops char(1), @prizn_occ char(1), @prizn_oms char(1), @fio_pf_card int
	declare	@mm1 int,  -- 
		@mm2 int,  -- 
		@yy int, --
		@gs_filial varchar(15), -- 
		@nom_korr int, -- 
		@period varchar(2) --   .

        select @mm1=end_mm-2, @mm2=end_mm, @yy=yy, @gs_filial=kod_ul,
           @nom_korr=n_korr, @period=otch_per
        from esss_2017_head where key_f=@key_ess

	--   .
	select  @erase_all = 1, @fio_pf_card = 0

	--@erase_all - 0  , 1 -    

	--  
	create table #pers (pers_id char (15) null)
	insert into #pers (pers_id) select distinct pers_id from pbpers4user 
        where header_key_f=@key_pbpers
	--end   

	create table #tmp_pers_ess (
		pers_id varchar(15) null,
		key_ess varchar(15) null,
		nom_korr smallint null,
		period varchar(2) null,
		year_ smallint null,
		nomer integer null,

		sex char (1) null,
		prizn_oms char (1) null,
		snils char (14) null,
		prizn_ops char (1) null,
		grajd varchar (3) null,
		kod_vid_doc varchar(2) null,
		inn_fl varchar(12) null,
		ser_nom_doc varchar (25) null,
		prizn_occ char (1) null,
		dt_r datetime null,

		name varchar (60) null,
		first_name varchar (60) null,
		sec_name varchar (60) null,

		cv_viplopc decimal (16,2) null,
		cv_kkl varchar(4) null,
		cv_viplopcd decimal (16,2) null,
		cv_nachcv decimal (16,2) null,
		cv_mm varchar(2) null,
		cv_sumvipl decimal (16,2) null,
		
		mm tinyint null,
		n_sc_soc integer null,
		summa_nalog decimal(16,4) null,
		summa_nalog_n decimal(16,4) null,
		sum_td decimal(16,4) null,
		sum_tgp decimal(16,4) null,
		summa_oblag_td decimal(16,4) null,
		summa_oblag_tgp decimal(16,4) null,
		tgp_summa_nalog decimal(16,4) null,
		tgp_summa_nalog_n decimal(16,4) null,
		sum_dop1_td decimal(16,4) null,
		sum_dop2_td decimal(16,4) null,
		sum_dop1_tgp decimal(16,4) null,
		sum_dop2_tgp decimal(16,4) null,
		
		sum_td_ost decimal(16,4) null,
		sum_tgp_ost decimal(16,4) null,
		summa_nalog_ost decimal(16,4) null,
		tgp_nalog_ost decimal(16,4) null,
		tabel_n varchar(32) null
		)


	if @erase_all = 0 
	begin
		delete pers_ess where key_ess = @key_ess and pers_id in (select pers_id from #pers)
		delete pers_ess_lgot where key_ess = @key_ess and pers_id in (select pers_id from #pers)
	end
	if @erase_all = 1
	begin
		delete pers_ess where key_ess = @key_ess
		delete pers_ess_lgot where key_ess = @key_ess
	end

	--. . 
	select @max_baza=max(xend) from table_nalog_soc
	where yy=@yy and code_nalog='6' and nomer_pp=1 and procent>0

	-- 
	insert into #tmp_pers_ess (pers_id, mm, year_, prizn_ops,prizn_oms,prizn_occ)
	select distinct rtrim(c.pers_id), s.mm, @yy,      2,         2,        2
	from #pers c,
	  (select 1 as mm union select 2 union select 3 union select 4 union select 5 union select 6
		 union select 7 union select 8 union select 9 union select 10 union select 11 union select 12
	  ) s
	where s.mm <= @mm2

	-- .
	update #tmp_pers_ess set n_sc_soc=(
	  select n_scala_soc from arhiv_const
	  where mm=#tmp_pers_ess.mm and yy=@yy
		and pers_id=#tmp_pers_ess.pers_id and whole<>0
	)

--    
	update #tmp_pers_ess 		
	set prizn_ops=1
        where n_sc_soc in (
           select id_scale from table_nalog_soc 
           where code_nalog='6' and yy=@yy and procent>0
        )

	update #tmp_pers_ess 		
	set prizn_oms=1
        where n_sc_soc in (
           select id_scale from table_nalog_soc 
           where code_nalog='3' and yy=@yy and procent>0
        )

	update #tmp_pers_ess 		
	set prizn_occ=1
        where n_sc_soc in (
           select id_scale from table_nalog_soc 
           where code_nalog='2' and yy=@yy and procent>0
        )

--    
        update esss_2017_sums set mm1=(
          select count(distinct pers_id) from #tmp_pers_ess
          where mm=@mm2 - 2 and prizn_ops=1
        )
        where key_head=@key_ess and razdel='1.1' and kod_str='010'

        update esss_2017_sums set mm2=(
          select count(distinct pers_id) from #tmp_pers_ess
          where mm=@mm2 - 1 and prizn_ops=1
        )
        where key_head=@key_ess and razdel='1.1' and kod_str='010'

        update esss_2017_sums set mm3=(
          select count(distinct pers_id) from #tmp_pers_ess
          where mm=@mm2 and prizn_ops=1
        )
        where key_head=@key_ess and razdel='1.1' and kod_str='010'

        update esss_2017_sums set vsego=(
          select count(distinct pers_id) from #tmp_pers_ess
          where mm between @mm1 and @mm2 and prizn_ops=1
        )
        where key_head=@key_ess and razdel='1.1' and kod_str='010'

        update esss_2017_sums set vsego_rp=(
          select count(distinct pers_id) from #tmp_pers_ess
          where prizn_ops=1
        )
        where key_head=@key_ess and razdel='1.1' and kod_str='010'


        update esss_2017_sums set mm1=(
          select count(distinct pers_id) from #tmp_pers_ess
          where mm=@mm2 - 2 and prizn_oms=1
        )
        where key_head=@key_ess and razdel='1.2' and kod_str='010'

        update esss_2017_sums set mm2=(
          select count(distinct pers_id) from #tmp_pers_ess
          where mm=@mm2 - 1 and prizn_oms=1
        )
        where key_head=@key_ess and razdel='1.2' and kod_str='010'

        update esss_2017_sums set mm3=(
          select count(distinct pers_id) from #tmp_pers_ess
          where mm=@mm2 and prizn_oms=1
        )
        where key_head=@key_ess and razdel='1.2' and kod_str='010'

        update esss_2017_sums set vsego=(
          select count(distinct pers_id) from #tmp_pers_ess
          where mm between @mm1 and @mm2 and prizn_oms=1
        )
        where key_head=@key_ess and razdel='1.2' and kod_str='010'

        update esss_2017_sums set vsego_rp=(
          select count(distinct pers_id) from #tmp_pers_ess
          where prizn_oms=1
        )
        where key_head=@key_ess and razdel='1.2' and kod_str='010'


        update esss_2017_sums set mm1=(
          select count(distinct pers_id) from #tmp_pers_ess
          where mm=@mm2 - 2 and prizn_occ=1
        )
        where key_head=@key_ess and razdel='2' and kod_str='010'

        update esss_2017_sums set mm2=(
          select count(distinct pers_id) from #tmp_pers_ess
          where mm=@mm2 - 1 and prizn_occ=1
        )
        where key_head=@key_ess and razdel='2' and kod_str='010'

        update esss_2017_sums set mm3=(
          select count(distinct pers_id) from #tmp_pers_ess
          where mm=@mm2 and prizn_occ=1
        )
        where key_head=@key_ess and razdel='2' and kod_str='010'

        update esss_2017_sums set vsego=(
          select count(distinct pers_id) from #tmp_pers_ess
          where mm between @mm1 and @mm2 and prizn_occ=1
        )
        where key_head=@key_ess and razdel='2' and kod_str='010'

        update esss_2017_sums set vsego_rp=(
          select count(distinct pers_id) from #tmp_pers_ess
          where prizn_occ=1
        )
        where key_head=@key_ess and razdel='2' and kod_str='010'

-- 
	update #tmp_pers_ess 
		set sex = c.sex, 
			name = c.name, 
			first_name = c.first_name, 
			sec_name = c.sec_name,
			snils = left(isnull(c.pf_strah_num, '00000000000'), 3) + '-' + SUBSTRING (isnull(c.pf_strah_num, '00000000000') , 4 , 3 ) + '-' + SUBSTRING (isnull(c.pf_strah_num, '00000000000') , 7 , 3 ) + '-' + RIGHT(rtrim(isnull(c.pf_strah_num, '00000000000')), 2),
			inn_fl = left(rtrim(ltrim(isnull(c.pers_inn, ''))), 12),
			ser_nom_doc = rtrim(isnull(c.pass_seria, '')) + ' ' + rtrim(isnull(c.pass_num, '')),
			dt_r = isnull(c.date_r, convert(datetime, '19000101')),
			kod_vid_doc = (select code from sp_vid_passports where code_old = isnull(c.pass_tip, '9')),
			cv_mm = right('0' + CONVERT(varchar, mm), 2),
	--		cv_mm = case when len(mm)= 1 then '0' + convert(varchar, mm) else convert(varchar, mm) end,
			cv_viplopc = 0.00,
			cv_viplopcd = 0.00,
			cv_nachcv = 0.00,
			cv_sumvipl = 0.00,
			grajd = case when c2.code_country>'' then c2.code_country else '643' end,
			tabel_n = c.tabel_n
	from const c, constik c2
	where #tmp_pers_ess.pers_id = rtrim(c.pers_id)
	and #tmp_pers_ess.pers_id = c2.pers_id

	--     
	if @fio_pf_card = 1 
	begin
		update #tmp_pers_ess 		
			set name = p.name, 
				first_name = p.first_name, 
				sec_name = p.sec_name
		from pf_strah_card p
		where #tmp_pers_ess.pers_id = rtrim(p.pers_id)
	end

--          (   1    -    )
        update #tmp_pers_ess set #tmp_pers_ess.nomer=t2.nomer, #tmp_pers_ess.prizn_ops=t2.prizn_ops,
           #tmp_pers_ess.prizn_oms=t2.prizn_oms, #tmp_pers_ess.prizn_occ=t2.prizn_occ  
	from 
           (    select distinct rank() OVER (ORDER BY name, first_name, sec_name, pers_id) as nomer, 
                     name, first_name, sec_name, pers_id, 
                     min(prizn_ops) as prizn_ops, min(prizn_oms) as prizn_oms, min(prizn_occ) as prizn_occ 
	  	from #tmp_pers_ess
		group by name, first_name, sec_name, pers_id
	   ) t2
	where #tmp_pers_ess.pers_id = t2.pers_id
 
-----         
        delete from #tmp_pers_ess where mm < @mm1
-----

	update #tmp_pers_ess set n_sc_soc=(
	  select n_scala_soc from const
	  where pers_id=#tmp_pers_ess.pers_id
	)
	where n_sc_soc is null

	--
	update #tmp_pers_ess set cv_kkl=(
	  select cat_pf from scale_comments
	  where #tmp_pers_ess.n_sc_soc=scale_comments.id_scale
		and scale_comments.yy=@yy  
	)

	update #tmp_pers_ess set cv_kkl=(
	  select category_pf from const
	  where pers_id=#tmp_pers_ess.pers_id
	)
	where cv_kkl is null


	--!!!!!!!!!!!!!!!!!!!!!!
	--   
	select pers_id,mm,yy,code_nalog, sum(summa_oblag) as baza, sum(nalog) as nal
	into #tmp_soc_tgp
	from arhiv_social where mm between @mm1 and @mm2 and yy=@yy
	  and pers_id in (select pers_id from #pers)
	  and code in (select code from sprav where tip_esss='dg')
	group by pers_id,mm,yy,code_nalog

	update #tmp_pers_ess set summa_oblag_tgp=baza, tgp_summa_nalog=nal
	from #tmp_soc_tgp where #tmp_soc_tgp.pers_id=#tmp_pers_ess.pers_id
	and #tmp_soc_tgp.mm=#tmp_pers_ess.mm and yy=#tmp_pers_ess.year_ and code_nalog='6'


	update #tmp_pers_ess set tgp_summa_nalog_n=nal
	from #tmp_soc_tgp where #tmp_soc_tgp.pers_id=#tmp_pers_ess.pers_id
	and #tmp_soc_tgp.mm=#tmp_pers_ess.mm and yy=year_ and code_nalog='7'

	update #tmp_pers_ess set sum_dop1_tgp=baza
	from #tmp_soc_tgp where #tmp_soc_tgp.pers_id=#tmp_pers_ess.pers_id
	and #tmp_soc_tgp.mm=#tmp_pers_ess.mm and yy=year_ and code_nalog='8'

	update #tmp_pers_ess set sum_dop2_tgp=baza
	from #tmp_soc_tgp where #tmp_soc_tgp.pers_id=#tmp_pers_ess.pers_id
	and #tmp_soc_tgp.mm=#tmp_pers_ess.mm and yy=year_ and code_nalog='9'


	drop table #tmp_soc_tgp

	--   
	select pers_id,mm,yy,code_nalog, sum(summa_oblag) as baza, sum(nalog) as nal
	into #tmp_soc_td
	from arhiv_social where mm between @mm1 and @mm2 and yy=@yy
	  and pers_id in (select pers_id from #pers)
	  and code not in (select code from sprav where tip_esss in ('-','dg'))
	group by pers_id,mm,yy,code_nalog

	update #tmp_pers_ess set summa_oblag_td=baza, summa_nalog=nal
	from #tmp_soc_td where #tmp_soc_td.pers_id=#tmp_pers_ess.pers_id
	and #tmp_soc_td.mm=#tmp_pers_ess.mm and yy=#tmp_pers_ess.year_ and code_nalog='6'

	update #tmp_pers_ess set summa_nalog_n=nal
	from #tmp_soc_td where #tmp_soc_td.pers_id=#tmp_pers_ess.pers_id
	and #tmp_soc_td.mm=#tmp_pers_ess.mm and yy=year_ and code_nalog='7'

	update #tmp_pers_ess set sum_dop1_td=baza
	from #tmp_soc_td where #tmp_soc_td.pers_id=#tmp_pers_ess.pers_id
	and #tmp_soc_td.mm=#tmp_pers_ess.mm and yy=year_ and code_nalog='8'

	update #tmp_pers_ess set sum_dop2_td=baza
	from #tmp_soc_td where #tmp_soc_td.pers_id=#tmp_pers_ess.pers_id
	and #tmp_soc_td.mm=#tmp_pers_ess.mm and yy=year_ and code_nalog='9'


	drop table #tmp_soc_td


	--rin 21/04/2014
	-- 
	--
	select pers_id,mm,yy,code_nalog, n_stat, sum(summa_oblag) as baza, sum(nalog) as nal
	into #tmp_dop
	from arhiv_social where mm between @mm1 and @mm2 and yy=@yy
		and isnull(n_stat,0)<> 0
	  and pers_id in (select pers_id from #pers)
	  and code not in (select code from sprav where tip_esss='-')
	group by pers_id,mm,yy,code_nalog, n_stat

	--  
	update #tmp_pers_ess set sum_tgp=isnull((
	  select sum(summa) from arhiv_ras
	  where ras_mm=#tmp_pers_ess.mm and ras_yy=@yy
		and pers_id=#tmp_pers_ess.pers_id 
		and code in (select code from sprav where dohod=1 and tip_esss='dg')
	),0)

	--  
	update #tmp_pers_ess set sum_td=isnull((
	  select sum(summa) from arhiv_ras
	  where arhiv_ras.ras_mm=#tmp_pers_ess.mm and ras_yy=@yy
		and pers_id=#tmp_pers_ess.pers_id 
		and code in (select code from sprav where dohod=1 and isnull(tip_esss,'') not in ('-','dg'))
	),0)


	--   
	create table #tmp_sum_pf(
	  pers_id varchar(15) null,
	  mm int null,
	  yy int null,
	  b_td decimal(16,4) null,
	  b_tgp decimal(16,4) null,
	  b_td_pr decimal(16,4) null,
	  b_tgp_pr decimal(16,4) null,
	  b_itog decimal(16,4) null,
	  n_td decimal(16,4) null,
	  n_tgp decimal(16,4) null,
	  n_td_pr decimal(16,4) null,
	  n_tgp_pr decimal(16,4) null,
	  n_itog decimal(16,4) null,
	  max_nalog decimal(16,4) null,
	  mm_pr int null,
	  mm_fix int null,
	  sc_soc int null
	)

	insert into #tmp_sum_pf (pers_id, 
								mm, 
								yy, 
								b_td, 
								b_tgp,
								n_td,
								n_tgp,
								sc_soc)
	select pers_id, 
			mm, 
			year_, 
			isnull(summa_oblag_td,0), 
			isnull(summa_oblag_tgp,0), 
			isnull(summa_nalog,0), 
			isnull(tgp_summa_nalog,0), 
			n_sc_soc
	from pers_ess
	where year_=@yy and mm<=@mm2 and pers_id in (select pers_id from #pers)


	insert #tmp_sum_pf(pers_id, mm, yy,
	  b_td, b_tgp, n_td, n_tgp,sc_soc)
	select pers_id, mm, year_,
	  isnull(summa_oblag_td,0), isnull(summa_oblag_tgp,0), isnull(summa_nalog,0), isnull(tgp_summa_nalog,0),n_sc_soc
	from #tmp_pers_ess
	where year_=@yy and mm<=@mm2


	--       
	update #tmp_sum_pf set b_itog=(
	  select sum(summa_oblag) from arhiv_social
	  where code_nalog='6' and yy=@yy and pers_id=#tmp_sum_pf.pers_id
	  and mm<=#tmp_sum_pf.mm
	)

	--    
	update #tmp_sum_pf set mm_pr=(
	  select min(mm) from #tmp_sum_pf t1 
	  where t1.b_itog > @max_baza and t1.pers_id=#tmp_sum_pf.pers_id
	  group by t1.pers_id
	)

	update #tmp_sum_pf set b_td_pr=b_td, b_td=0,
	  b_tgp_pr=b_tgp, b_tgp=0
	where mm > mm_pr

	update #tmp_sum_pf set b_td_pr = case when b_td<=0 then 0 else (b_itog - @max_baza)*b_td /(b_td + b_tgp) end
	where mm = mm_pr
	update #tmp_sum_pf set b_tgp_pr = (b_itog - @max_baza) - b_td_pr
	where mm = mm_pr

	update #tmp_sum_pf set b_tgp = b_tgp - b_tgp_pr, b_td=b_td - b_td_pr
	where mm = mm_pr

	--       
	update #tmp_sum_pf set n_itog=(
	  select sum(nalog) from arhiv_social
	  where code_nalog='6' and yy=@yy and pers_id=#tmp_sum_pf.pers_id
	  and mm<=#tmp_sum_pf.mm
	)

	update #tmp_sum_pf set max_nalog=(
	  select min_summa from table_nalog_soc
	  where code_nalog='6' and yy=@yy and id_scale=#tmp_sum_pf.sc_soc
		and nomer_pp=2
	)

	-----!
	--
	update #tmp_sum_pf set mm_fix=(
	  select case when month_inv>0 then month_inv else month_restart end
	  from soc_pers_settings where yy=@yy
		and pers_id=#tmp_sum_pf.pers_id
	)

	update #tmp_sum_pf set max_nalog=max_nalog * (1 -
		(select case when max_nalog>0 and n_itog>0 then n_itog/max_nalog else 0 end
		 from #tmp_sum_pf t1 where t1.mm=t1.mm_fix and t1.pers_id=#tmp_sum_pf.pers_id)
	  )
	where mm=mm_pr and mm_fix < mm_pr

	--update #tmp_sum_pf set mm_pr=(
	--  select min(mm) from #tmp_sum_pf t1 
	--  where t1.n_itog > max_nalog and t1.pers_id=#tmp_sum_pf.pers_id
	--  group by t1.pers_id
	--)

	update #tmp_sum_pf set n_td_pr=n_td, n_tgp_pr=n_tgp, n_tgp = 0, n_td=0
	where mm > mm_pr

	update #tmp_sum_pf set n_td_pr = case when n_td<=0 then 0 else (n_itog - max_nalog)*n_td /(n_td + n_tgp) end
	where mm = mm_pr
	update #tmp_sum_pf set n_tgp_pr = (n_itog - max_nalog) - n_td_pr
	where mm = mm_pr

	update #tmp_sum_pf set n_tgp = n_tgp - n_tgp_pr, n_td=n_td - n_td_pr
	where mm = mm_pr

	--  . 
	update #tmp_pers_ess set summa_oblag_td=b_td, summa_oblag_tgp=b_tgp, sum_td_ost=b_td_pr, sum_tgp_ost=b_tgp_pr,
		summa_nalog=n_td, tgp_summa_nalog=n_tgp, summa_nalog_ost=n_td_pr, tgp_nalog_ost=n_tgp_pr
	from #tmp_sum_pf where #tmp_sum_pf.pers_id=#tmp_pers_ess.pers_id
	  and #tmp_sum_pf.mm=#tmp_pers_ess.mm and yy=year_ 
	  and #tmp_sum_pf.mm between @mm1 and @mm2

	--NULL to 0
	update #tmp_pers_ess set summa_nalog_n=isnull(summa_nalog_n, 0), tgp_summa_nalog_n=isnull(tgp_summa_nalog_n, 0),
		   sum_dop1_td=isnull(sum_dop1_td, 0), sum_dop2_td=isnull(sum_dop2_td, 0),
		   sum_dop1_tgp=isnull(sum_dop1_tgp, 0), sum_dop2_tgp=isnull(sum_dop2_tgp, 0)

	--   -       
	create table #okrugl(
	  pers_id varchar(15) null,
	  delta_td decimal(6,4) null,
	  delta_tgp decimal(6,4) null,
	  delta_int_td decimal(6,2) null,
	  delta_int_tgp decimal(6,2) null,
	  mm_td int null,
	  mm_tgp int null
	)

	declare @delta decimal(16,4), @pid varchar(15),@znak int,@i int
	set @i=1
	while @i<=2
	begin

		if @i=1 --
		begin
		  insert #okrugl (pers_id,delta_td,delta_tgp,delta_int_td,delta_int_tgp)
		  select pers_id, sum(summa_nalog)-sum(round(summa_nalog,2)),
			sum(tgp_summa_nalog)-sum(round(tgp_summa_nalog,2)),0,0
		  from #tmp_pers_ess
--		  where year_=@yy and mm between @mm1 and @mm2
--			and pers_id in (select pers_id from #pers)
		  group by pers_id 

		  update #tmp_pers_ess set tgp_summa_nalog=round(tgp_summa_nalog,2), summa_nalog=round(summa_nalog,2)
--		  where year_=@yy and mm between @mm1 and @mm2
--			and pers_id in (select pers_id from #pers)
		end
		else
		begin
		  delete from #okrugl

		  insert #okrugl (pers_id,delta_td,delta_tgp,delta_int_td,delta_int_tgp)
		  select pers_id, sum(summa_nalog_n)-sum(round(summa_nalog_n,2)),
			sum(tgp_summa_nalog_n)-sum(round(tgp_summa_nalog_n,2)),0,0
		  from #tmp_pers_ess
--		  where year_=@yy and mm between @mm1 and @mm2
--			and pers_id in (select pers_id from #pers)
		  group by pers_id 

		  update #tmp_pers_ess set tgp_summa_nalog_n=round(tgp_summa_nalog_n,2), summa_nalog_n=round(summa_nalog_n,2)
--		  where year_=@yy and mm between @mm1 and @mm2
--			and pers_id in (select pers_id from #pers)
		end

		delete from #okrugl where delta_td+delta_tgp=0

		update #okrugl set mm_td=(
		  select max(mm) from #tmp_pers_ess t1 
		  where t1.summa_nalog<>0 and t1.pers_id=#okrugl.pers_id and 
			t1.mm between @mm1 and @mm2 and t1.year_=@yy
		  group by t1.pers_id )

		update #okrugl set mm_tgp=(
		  select max(mm) from #tmp_pers_ess t1 
		  where t1.tgp_summa_nalog<>0 and t1.pers_id=#okrugl.pers_id and 
			t1.mm between @mm1 and @mm2 and t1.year_=@yy
		  group by t1.pers_id )

		update #okrugl set delta_int_td=round(delta_td,2),
		  delta_td=delta_td - round(delta_td,2) 
		where abs(delta_td)>0.005

		update #okrugl set delta_int_tgp=round(delta_tgp,2),
		  delta_tgp=delta_tgp - round(delta_tgp,2)
		where abs(delta_tgp)>0.005

		update #okrugl set delta_int_td=delta_int_td+round(delta_td+delta_tgp,2),
		  delta_td=delta_td+delta_tgp - round(delta_td+delta_tgp,2), delta_tgp=0 
		where abs(delta_td+delta_tgp)>0.005

		select @delta = sum(delta_td+delta_tgp)
		from #okrugl

		select @znak=case when @delta>0 then 1 else -1 end

		if abs(@delta)>0.005
		begin
		  declare delta_cur cursor for select pers_id
		  from #okrugl where (delta_td + delta_tgp)*@znak > 0 and mm_td>0
		  order by abs(delta_td + delta_tgp) desc
		  
		  open delta_cur
		  fetch delta_cur into @pid
		  while @@fetch_status=0
		  begin
			update #okrugl set delta_int_td=delta_int_td+0.01*@znak where pers_id=@pid
			set @delta=@delta - 0.01*@znak
			if abs(@delta)<0.005 break

			fetch delta_cur into @pid
		  end

		  close delta_cur
		  deallocate delta_cur
		end

		if @i=1
		begin
		update #tmp_pers_ess set summa_nalog=summa_nalog+delta_int_td
		from #okrugl
		where #tmp_pers_ess.pers_id=#okrugl.pers_id and year_=@yy
		  and mm=mm_td

		update #tmp_pers_ess set  tgp_summa_nalog=tgp_summa_nalog+delta_int_tgp
		from #okrugl
		where #tmp_pers_ess.pers_id=#okrugl.pers_id and year_=@yy
		  and mm=mm_tgp
		end
		else
		begin
		update #tmp_pers_ess set summa_nalog_n=summa_nalog_n+delta_int_td
		from #okrugl
		where #tmp_pers_ess.pers_id=#okrugl.pers_id and year_=@yy
		  and mm=mm_td

		update #tmp_pers_ess set  tgp_summa_nalog_n=tgp_summa_nalog_n+delta_int_tgp
		from #okrugl
		where #tmp_pers_ess.pers_id=#okrugl.pers_id and year_=@yy
		  and mm=mm_tgp
		end
		set @i=@i+1

	end

--	delete #tmp_pers_ess where mm < @mm1
	update #tmp_pers_ess set cv_sumvipl = isnull(sum_td, 0) + isnull(sum_tgp, 0), 
							cv_viplopc = isnull(summa_oblag_td, 0) + isnull(summa_oblag_tgp, 0),
							cv_viplopcd = isnull(summa_oblag_tgp, 0),
							cv_nachcv = isnull(summa_nalog, 0) + isnull(tgp_summa_nalog, 0)
--	delete pers_ess where year_ = @yy and mm between @mm1 and @mm2

	--  .
	update #tmp_dop set n_stat = case n_stat when 31 then 27
            when 32 then 26 when 33 then 25 when 34 then 24 when 4 then 23 else n_stat
        end

	--   ...      
	insert into pers_ess (	key_ess,
							pers_id,
							nom_korr,
							period,
							year_,
							nomer,
							data_,
							sex,
							prizn_oms,
							snils,
							prizn_ops,
							grajd,
							kod_vid_doc,
							inn_fl,
							ser_nom_doc,
							prizn_occ,
							dt_r,
							name,
							first_name,
							sec_name,
							cv_viplopc,
							cv_kkl,
							cv_viplopcd,
							cv_nachcv,
							cv_mm,
							cv_sumvipl,
							mm,
							n_sc_soc,
							summa_oblag_tgp,
							tgp_summa_nalog,
							summa_oblag_td,
							summa_nalog,
							sum_tgp,
							sum_td,
							tgp_summa_nalog_n,
							sum_dop1_tgp,
							sum_dop2_tgp,
							summa_nalog_n,
							sum_dop1_td,
							sum_dop2_td,
							tabel_n
							)
	select @key_ess,
							pers_id,
							@nom_korr as nom_korr,
							@period as period,
							year_,
							nomer,
							getdate() as data_,
							isnull(sex, 1) as sex,
							prizn_oms,
							isnull(snils, '000-000-000-00') as snils,
							prizn_ops,
							grajd,
							kod_vid_doc,
							inn_fl,
							ser_nom_doc,
							prizn_occ,
							dt_r,
							name,
							first_name,
							sec_name,
							cv_viplopc,
							cv_kkl,
							cv_viplopcd,
							cv_nachcv,
							cv_mm,
							cv_sumvipl,
							mm,
							n_sc_soc,
							summa_oblag_tgp,
							tgp_summa_nalog,
							summa_oblag_td,
							summa_nalog,
							sum_tgp,
							sum_td,
							tgp_summa_nalog_n,
							sum_dop1_tgp,
							sum_dop2_tgp,
							summa_nalog_n,
							sum_dop1_td,
							sum_dop2_td,
							tabel_n
	from #tmp_pers_ess
	order by nomer

	--    

	insert into pers_ess_lgot (
			key_ess,
			pers_id,
			vcvd_viplcv,
			vcvd_nachcv,
			vcvd_mm,
			vcvd_tarif)
	select @key_ess,
			pers_id,
			round(baza, 2),
			round(nal, 2),
			right('0' + convert(varchar, mm), 2),
			n_stat
	from #tmp_dop

	drop table #pers
	drop table #tmp_pers_ess
	drop table #okrugl
	drop table #tmp_sum_pf
	drop table #tmp_dop
	--select * from pers_ess
	--select * from pers_ess_lgot
go

if object_id('dbo.sp_pers_ess') is not null 
  GRANT EXECUTE ON dbo.sp_pers_ess TO AitUsers
GO



if exists(select * from sysobjects where name='sp_esss_2017')
  drop procedure sp_esss_2017
go
create procedure sp_esss_2017 @kod_ul varchar(15), @beg_mm tinyint, @end_mm tinyint, @yy smallint, 
                          @kf varchar(15), @key_head varchar(15)
as
  declare @otch_per tinyint, @i int, @okved varchar(15), @inostr_in_oms char(1),
          @osn_sp1 char(1), @osn_sp2 char(1), @delta decimal(16,2), @is_dop char(1), @is_r5 char(1)
  declare @sql varchar(1000), @scales_inostr varchar(20), @scales_inv varchar(20), @max_oblag_baza decimal(16,2),
          @codes_tarif varchar(25), @smm varchar(3), @col varchar(10), @vozm_mm1 decimal(16,2),
          @vozm_mm2 decimal(16,2), @vozm_mm3 decimal(16,2), @vozm_rp decimal(16,2)

  set @otch_per=case when @beg_mm<>1 then 0 else
     case @end_mm when 3 then 21 when 6 then 31 when 9 then 33 when 12 then 34 else 0 end
  end  

  delete from esss_2017_head where key_f=@key_head
  delete from esss_2017_sums where key_head=@key_head
  delete from esss_2017_fss where key_head=@key_head
  delete from esss_inostr where key_head=@key_head

  select @scales_inostr=rtrim(scales_inostr), @scales_inv=rtrim(scales_inv), @codes_tarif=codes_tarif,
         @inostr_in_oms=fl_inostr_in_oms, @okved=okved, @osn_sp1=osn_24_sp1,
         @osn_sp2=osn_24_sp2, @is_r5=fl_r5, @vozm_mm1 = vozm_fss_mm1,
         @vozm_mm2 = vozm_fss_mm2, @vozm_mm3 = vozm_fss_mm3
  from ust_rsv where kod_ul=@kod_ul

--    
  if @vozm_mm1 is null set @vozm_mm1=0
  if @vozm_mm2 is null set @vozm_mm2=0
  if @vozm_mm3 is null set @vozm_mm3=0
  set @vozm_rp = @vozm_mm1 + @vozm_mm2 + @vozm_mm3
  if @end_mm>3
     set @vozm_rp=@vozm_rp+isnull((
        select sum(vsego_rp) from esss_2017_sums
        where razdel='2' and kod_str='080' and key_head in (
             select key_f from esss_2017_head
             where kod_ul=@kod_ul and yy=@yy and end_mm<@end_mm 
           )
     ),0)  

--
  insert into esss_2017_head (key_f,kod_ul,otch_per,yy,date_,n_korr,po_mestu, end_mm,kod_tarifa,prizn_vipl_fss,
                              okved, osn_sp1, osn_sp2, n_file)
  select @key_head,@kod_ul, @otch_per, @yy, getdate(),'000','214',@end_mm,'01','1',
                              @okved, @osn_sp1, @osn_sp2, newid()

  if @kod_ul='1'
    update esss_2017_head set name_pred=pred 
    from ust
    where esss_2017_head.key_f=@key_head
  else
    update esss_2017_head set name_pred=pred 
    from ust_filial 
    where ust_filial.key_f=@kod_ul and esss_2017_head.key_f=@key_head

  update esss_2017_head set esss_2017_head.kod_no=ust_nlg.code_gni,
      esss_2017_head.tlf=ust_nlg.telephone,
      esss_2017_head.inn=ust_nlg.inn,
      esss_2017_head.kpp=ust_nlg.code_case,
      esss_2017_head.oktmo=ust_nlg.oktmo,
      esss_2017_head.pr_podp=ust_nlg.podpisant,
      esss_2017_head.fam_podp=case when ust_nlg.podpisant='2' then ust_nlg.fam_upoln else ust_nlg.familia end,
      esss_2017_head.im_podp=case when ust_nlg.podpisant='2' then ust_nlg.imya_upoln else ust_nlg.imya end,
      esss_2017_head.ot_podp=case when ust_nlg.podpisant='2' then ust_nlg.otch_upoln else ust_nlg.otchestvo end,
      esss_2017_head.dok_predst=case when ust_nlg.podpisant='2' then ust_nlg.doc_upoln else '' end
  from ust_nlg 
  where ust_nlg.key_f=@kod_ul and esss_2017_head.key_f=@key_head

  --  
  --   ,      2010

  if @scales_inostr>'' 
  begin
    if right(@scales_inostr,1)=',' set @scales_inostr=left(@scales_inostr,len(@scales_inostr)-1)
  end
  else
    set @scales_inostr='0'

    set @scales_inv='0'


  select @max_oblag_baza = min(xend) from table_nalog_soc
  where yy=@yy and nomer_pp=1 and code_nalog='6' and procent>0

  select pers_id into #tmp_arhsoc_persons
  from pbpers4user where header_key_f=@kf

  create table #tmp_arhsoc_sn_scales_nerez(
    scala int null
  )

  set @sql='insert #tmp_arhsoc_sn_scales_nerez(scala) '+
         'select distinct id_scale from table_nalog_soc '+
         'where id_scale in ('+@scales_inostr+')'
  exec(@sql)


  select arhiv_social.pers_id,
       arhiv_social.mm,
       arhiv_social.yy,
       arhiv_social.code, 
       arhiv_social.code_nalog,
       arhiv_social.summa,
       arhiv_social.nalog, 
       arhiv_social.summa_oblag , 
       arhiv_social.fl_vmen,
       arhiv_social.n_stat
  into #tmp_arhiv_social 
  from #tmp_arhsoc_persons, arhiv_social 
  where #tmp_arhsoc_persons.pers_id = arhiv_social.pers_id 
    and arhiv_social.mm <= @end_mm 
    and arhiv_social.yy = @yy  
    and arhiv_social.code not in (select code from sprav where tip_esss='-')

  --  ,     
  create table #tmp_arhsoc_2010 (
	pers_id varchar(15) null, 
	const_scala int null, 
	arhconst_scala_soc int null, 
	arhconst_scala int null, 
	code_nalog char(1) null, 
	mm int null, 
	yy int null, 
	whole decimal(16,5) null, 
	summa decimal(16,5) null, 
	summa_oblag decimal(16,5) null, 
	nalog decimal(16,5) null, 
	sum25 decimal(16,5) null, 
	sum26 decimal(16,5) null, 
	fl_inostr char(1) null, 
	summa_inostr decimal(16,5) null, 
	scale_code varchar(2) null,
        month_fix int null 
  )
  create table #inv (
	pers_id varchar(15) not null primary key, 
	all1 decimal(16,4) null, 
	kvart1 decimal(16,4) null, 
	mm1 decimal(16,4) null, 
	mm2 decimal(16,4) null, 
	mm3  decimal(16,4) null
  )
  create table #tmp_results(
    scale_code char(2) null,
    code_nalog char(1) null,
    mm int null, 
    yy int null,
    whole decimal(16,2) null,
    summa decimal(16,2) null,
    summa_oblag decimal(16,2) null, 
    nalog decimal(16,2) null, 
    sum25 decimal(16,2) null,
    sum26 decimal(16,2) null,
    type_ char(2) null,
    kolvo int null
  )

  declare @p_in3 int
  set @p_in3=case when @inostr_in_oms='1' then 1 else 0 end

  --   ait_soc_2010.
  exec usp_get_arhsoc_sums @p_start_mm =1,
     @p_end_mm =@end_mm,
     @p_year =@yy,
     @p_fl_inostr_1 = 0,
     @p_fl_inostr_2 = 0,
     @p_fl_inostr_3 = @p_in3,
     @p_fl_inostr_4 = 0,
     @p_codes25= '',
     @p_codes26= '',
     @p_scales25= '',
     @p_scales26= '',
     @p_fl_vmen = '0', 
     @p_fl_novmen_in_db = '1',
     @p_is_log_enabled = '0'


  exec usp_get_arhsoc_2010 '', '', @scales_inv, '',
	'', '', @max_oblag_baza,'0', '0', 
        1, @end_mm, @yy, 2, 2, 0

--  
  insert esss_inostr(key_head, pers_id,l_name,f_name,s_name,snils,inn,gragd)
  SELECT @key_head, const.pers_id,   
         const.name, const.first_name, isnull(const.sec_name,'') as sec_name,   
	 left(const.pf_strah_num,3) + '-' + SUBSTRING(const.pf_strah_num,4,3) + '-' + 
             SUBSTRING(const.pf_strah_num,7,3) + '-' + RIGHT(rtrim(const.pf_strah_num),2),
         const.pers_inn,
         constik.code_country  
  FROM const, constik   
  where const.pers_id in (select pers_id from pbpers4user where header_key_f=@kf)
    and const.pers_id in (select pers_id from arhiv_const where yy=@yy and mm <= @end_mm
           and n_scala_soc in (select scala from #tmp_arhsoc_sn_scales_nerez))
    and const.pers_id=constik.pers_id
    and isnull(const.status_nlg, 1) <> 3

  update esss_inostr set mm1=(
    select whole from arhiv_const where pers_id=esss_inostr.pers_id
        and yy=@yy and mm=@end_mm - 2
  ) 
  where key_head=@key_head

  update esss_inostr set mm2=(
    select whole from arhiv_const where pers_id=esss_inostr.pers_id
        and yy=@yy and mm=@end_mm - 1
  ) 
  where key_head=@key_head

  update esss_inostr set mm3=(
    select whole from arhiv_const where pers_id=esss_inostr.pers_id
        and yy=@yy and mm=@end_mm 
  ) 
  where key_head=@key_head

  update esss_inostr set vsego_rp=(
    select sum(whole) from arhiv_const where pers_id=esss_inostr.pers_id
        and yy=@yy and mm<=@end_mm 
  ) 
  where key_head=@key_head

  update esss_inostr set mm1=isnull(mm1,0),mm2=isnull(mm2,0),mm3=isnull(mm3,0),
                         vsego_rp=isnull(vsego_rp,0)
  where key_head=@key_head

 
  update esss_inostr set vsego = mm1 + mm2 + mm3
  where key_head=@key_head

-- 
create table #tmp_fss(
  pid varchar(15) null,
  razd char(2) null,
  mes int null,
  x_ind varchar(15) null,
  sum_ decimal(16,2) null,
  dni_ decimal(16,2) null,
  kod_str char(3) null,
  pers_mm varchar(20) null
)

insert #tmp_fss(pid, mes, razd, x_ind, sum_, dni_, kod_str,pers_mm)
select pers_id,ras_mm, 
  case when left(sprav.tip_esss,1)='f' then '3' else '4'+left(sprav.tip_esss,1) end, 
  case when right(sprav.tip_esss,1) in ('b','d') then isnull(x_indication,'') else pers_id end, 
  ar.summa, ar.days, 
  case when left(sprav.tip_esss,1)='f' then
    case right(sprav.tip_esss,1) when 'b' then '010' when 'd' then '030' when 'e' then '040' when 'r' then '050'
      when '1' then '061' when '2' then '062' when 'i' then '070' when 'p' then '090' else '' end
  else
    case right(sprav.tip_esss,1) when 'b' then '020' when 'd' then '030'
      when '1' then '050' when '2' then '060' else '' end
  end,
  rtrim(pers_id)+'*'+convert(varchar(2),ras_mm)
from arhiv_ras ar, sprav
where ar.pers_id in (select pers_id from pbpers4user where header_key_f=@kf)
  and ar.ras_yy=@yy and ar.ras_mm<=@end_mm
  and ar.code=sprav.code
  and isnull(sprav.tip_esss,'') not in ('','-')

-- ,      
delete from #tmp_fss where isnull(kod_str,'')=''

  insert esss_2017_sums (key_head, kbk, kod_str, razdel, kod_tarif)
  values (@key_head,'18210202010061010160','020','1','01')
  insert esss_2017_sums (key_head, kbk, kod_str, razdel, kod_tarif)
  values (@key_head,'18210202101081013160','040','1','01')
-- 060    
  insert esss_2017_sums (key_head, kbk, kod_str, razdel, kod_tarif)
  values (@key_head,'18210202080061010160','080','1','01')
  insert esss_2017_sums (key_head, kbk, kod_str, razdel, kod_tarif)
  values (@key_head,'18210202090071010160','100','1','01')
  insert esss_2017_sums (key_head, kbk, kod_str, razdel, kod_tarif)
  values (@key_head,'','120','1','01')

-- 1.1  1.2
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'010','1.1','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'020','1.1','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'021','1.1','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'030','1.1','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'040','1.1','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'050','1.1','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'051','1.1','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'060','1.1','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'061','1.1','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'062','1.1','01')

  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'010','1.2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'020','1.2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'030','1.2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'040','1.2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'050','1.2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'060','1.2','01')

-- 2
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'010','2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'020','2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'030','2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'040','2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'050','2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'051','2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'052','2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'053','2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'054','2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'060','2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'070','2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif, vsego_rp, mm1,mm2,mm3)
  values (@key_head,'080','2','01',@vozm_rp, @vozm_mm1, @vozm_mm2, @vozm_mm3)
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
  values (@key_head,'090','2','01')
  insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif, vsego_rp,vsego,mm1,mm2,mm3)
  values (@key_head,'100','2','01',1,1,1,1,1)

  --  
  select @is_dop=value_f from cfg_reg_values where app_id=1
    and mode_id='w_ras_dw' and param_id='vred_tarif'

  if @is_dop='1'
  begin
    --    
    select n_stat, code_nalog, mm, sum(summa) as summa, sum(summa_oblag) as summa_oblag,
           sum(nalog) as nalog, count(distinct case when nalog>0 then pers_id else null end) as kolvo
    into #tmp_dop_vznos 
    from #tmp_arhiv_social
    where code_nalog in ('8','9')
    group by n_stat, code_nalog, mm

    insert into #tmp_dop_vznos (n_stat, code_nalog, mm, summa, summa_oblag, nalog, kolvo)
    select n_stat, code_nalog, -10, sum(summa), sum(summa_oblag), sum(nalog), count(distinct case when nalog>0 then pers_id else null end)
    from #tmp_arhiv_social
    where code_nalog in ('8','9')
    group by n_stat, code_nalog

    insert into #tmp_dop_vznos (n_stat, code_nalog, mm, summa, summa_oblag, nalog, kolvo)
    select n_stat, code_nalog, -100, sum(summa), sum(summa_oblag), sum(nalog), count(distinct case when nalog>0 then pers_id else null end)
    from #tmp_arhiv_social
    where code_nalog in ('8','9') and mm>=@end_mm - 2
    group by n_stat, code_nalog

-- 1.31
    insert esss_2017_sums (key_head, kod_tarif, kod_str, razdel)
    select @key_head, t22.spis, t22.nn, '1.31'
    from (
       select '010' as nn, '121' as spis union
       select '020','121' union
       select '030','121' union
       select '040','121' union
       select '050','121' union

       select '010','222' union
       select '020','222' union
       select '030','222' union
       select '040','222' union
       select '050','222'
    ) t22;

-- 1.32   1  2
    insert esss_2017_sums (key_head, kod_tarif, kod_str, razdel)
    select @key_head, s.spis+t24.razd, t24.nn, '1.32'
    from (
       select '010' as nn, '04' as razd union
       select '020', '04' union
       select '030', '04' union
       select '040', '04' union
       select '050', '04' union
       select '010', '31' union
       select '020', '31' union
       select '030', '31' union
       select '040', '31' union
       select '050', '31' union
       select '010', '32' union
       select '020', '32' union
       select '030', '32' union
       select '040', '32' union
       select '050', '32' union
       select '010', '33' union
       select '020', '33' union
       select '030', '33' union
       select '040', '33' union
       select '050', '33' union
       select '010', '34' union
       select '020', '34' union
       select '030', '34' union
       select '040', '34' union
       select '050', '34'
    ) t24,
    (  select '1' as spis union
       select '2' 
    ) s;
  end

-- 5
  if @is_r5='1'
  begin
    insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
    values (@key_head,'010','5','01')
    insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
    values (@key_head,'020','5','01')
    insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
    values (@key_head,'030','5','01')
    insert esss_2017_sums (key_head, kod_str, razdel, kod_tarif)
    values (@key_head,'040','5','01')
  end

  set @i=0
  while @i<=3
  begin
    if @i=0
    begin
	set @col='vsego_rp'
	set @smm='-10'
    end
    else
    begin
	set @col='mm'+convert(varchar(2),@i)
	set @smm=convert(varchar(2), @beg_mm + @i - 1)
    end
 
    set @sql='update esss_2017_sums set '+@col+' = ( '+
                 'select sum(nalog) from #tmp_results '+
                 'where code_nalog=''6'' and type_=''st'' '+
                 'and mm='+ @smm+ 
             ') where key_head='''+@key_head+''' and kod_str=''020'' and razdel=''1'''  
    exec(@sql)

    set @sql='update esss_2017_sums set '+@col+' = ( '+
                 'select sum(nalog) from #tmp_results '+
                 'where code_nalog=''3'' and type_=''st'' '+
                 'and mm='+ @smm+ 
             ') where key_head='''+@key_head+''' and kod_str=''040'' and razdel=''1'''  
    exec(@sql)

--    set @sql='update esss_2017_sums set '+@col+' = ( '+
--                 'select sum(nalog) from #tmp_results '+
--                 'where code_nalog in (''8'',''9'') and type_=''st'' '+
--                 'and mm='+ @smm+ 
--             ') where key_head='''+@key_head+''' and kod_str=''060'' and razdel=''1'''  
--    exec(@sql)

--. . (. 080)   !

    set @sql='update esss_2017_sums set '+@col+' = ( '+
                 'select sum(nalog) from #tmp_results '+
                 'where code_nalog =''2'' and type_=''st'' '+
                 'and mm='+ @smm+ 
             ') where key_head='''+@key_head+''' and kod_str=''060'' and razdel=''2'''  
    exec(@sql)

    if @i=0
      set @sql='update esss_2017_sums set '+@col+' = ( '+
                 'select sum(sum_) from #tmp_fss'+
               ') where key_head='''+@key_head+''' and kod_str=''070'' and razdel=''2'''  
    else
      set @sql='update esss_2017_sums set '+@col+' = ( '+
                 'select sum(sum_) from #tmp_fss '+
                 'where mes='+ convert(varchar,@end_mm-3+@i)+ 
               ') where key_head='''+@key_head+''' and kod_str=''070'' and razdel=''2'''  
    exec(@sql)

    set @i=@i+1 
  end

declare @delta_vsego decimal(16,2)
  set @delta=isnull((select vsego_rp from esss_2017_sums 
                     where key_head=@key_head and kod_str='060' and razdel='2'),0) -
             isnull((select vsego_rp from esss_2017_sums 
                     where key_head=@key_head and kod_str='070' and razdel='2'),0) + @vozm_rp
  if @delta>0
    update esss_2017_sums set vsego_rp= @delta where key_head=@key_head and 
        ( kod_str='100' and razdel='1' or kod_str='090' and razdel='2')
  else
    update esss_2017_sums set vsego_rp= (-1)* @delta where key_head=@key_head and 
        ( kod_str='120' and razdel='1' or kod_str='090' and razdel='2')

  set @delta=isnull((select mm1 from esss_2017_sums 
                     where key_head=@key_head and kod_str='060' and razdel='2'),0) -
             isnull((select mm1 from esss_2017_sums 
                     where key_head=@key_head and kod_str='070' and razdel='2'),0) + @vozm_mm1
  set @delta_vsego=@delta
  if @delta>0
    update esss_2017_sums set mm1= @delta where key_head=@key_head and 
        ( kod_str='100' and razdel='1' or kod_str='090' and razdel='2')
  else
    update esss_2017_sums set mm1= (-1)* @delta where key_head=@key_head and 
        ( kod_str='120' and razdel='1' or kod_str='090' and razdel='2')

  set @delta=isnull((select mm2 from esss_2017_sums 
                     where key_head=@key_head and kod_str='060' and razdel='2'),0) -
             isnull((select mm2 from esss_2017_sums 
                     where key_head=@key_head and kod_str='070' and razdel='2'),0) + @vozm_mm2 
  set @delta_vsego=@delta_vsego+@delta
  if @delta>0
    update esss_2017_sums set mm2= @delta where key_head=@key_head and 
        ( kod_str='100' and razdel='1' or kod_str='090' and razdel='2')
  else
    update esss_2017_sums set mm2= (-1)* @delta where key_head=@key_head and 
        ( kod_str='120' and razdel='1' or kod_str='090' and razdel='2')

  set @delta=isnull((select mm3 from esss_2017_sums 
                     where key_head=@key_head and kod_str='060' and razdel='2'),0) -
             isnull((select mm3 from esss_2017_sums 
                     where key_head=@key_head and kod_str='070' and razdel='2'),0) + @vozm_mm3
  set @delta_vsego=@delta_vsego+@delta
  if @delta>0
    update esss_2017_sums set mm3= @delta where key_head=@key_head and 
        ( kod_str='100' and razdel='1' or kod_str='090' and razdel='2')
  else
    update esss_2017_sums set mm3= (-1)* @delta where key_head=@key_head and 
        ( kod_str='120' and razdel='1' or kod_str='090' and razdel='2')

  if @delta_vsego>0
    update esss_2017_sums set vsego= @delta_vsego where key_head=@key_head and 
        ( kod_str='100' and razdel='1' or kod_str='090' and razdel='2')
  else
    update esss_2017_sums set vsego= (-1)* @delta_vsego where key_head=@key_head and 
        ( kod_str='120' and razdel='1' or kod_str='090' and razdel='2')


  set @i=0
  while @i<=3
  begin
    if @i=0
    begin
      set @smm='-10'
      set @col='vsego_rp'
    end
    else
    begin
      set @col='mm'+convert(varchar(2),@i)
      set @smm=convert(varchar(2), @beg_mm + @i - 1)
    end

    -- 
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(whole) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''f1'',''f2'') and type_=''st'''+
             '    and code_nalog=6) '+     
             'where key_head='''+@key_head+''' and razdel=''1.1'' and kod_str=''030'''
    exec(@sql)
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(whole) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''f1'',''f2'') and type_=''st'''+
             '    and code_nalog=3) '+     
             'where key_head='''+@key_head+''' and razdel=''1.2'' and kod_str=''030'''
    exec(@sql)
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(whole) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''f1'',''f2'') and type_=''st'''+
             '    and code_nalog=2) '+     
             'where key_head='''+@key_head+''' and razdel=''2'' and kod_str=''020'''
    exec(@sql)
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum('+@col+') from esss_inostr'+
             '  where key_head='''+@key_head+''') '+
             'where key_head='''+@key_head+''' and razdel=''2'' and kod_str=''054'''
    exec(@sql)

    if @is_dop='1'
    begin
      set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(summa) from #tmp_dop_vznos'+
             '  where mm='+@smm+
             '    and code_nalog=case when left(esss_2017_sums.kod_tarif,1)=''1'' then ''8'' else ''9'' end '+ 
             '    and n_stat=convert(int,right(esss_2017_sums.kod_tarif,2))) '+     
             'where key_head='''+@key_head+''' and razdel in (''1.31'',''1.32'') and kod_str=020'
      exec(@sql)
   end


    -- 
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(whole) - isnull(sum(summa_oblag),0) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''n2'',''f1'',''f2'') and type_=''st'''+
             '    and code_nalog=6) '+     
             'where key_head='''+@key_head+''' and razdel=''1.1'' and kod_str=040'
    exec(@sql)
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(whole) - isnull(sum(summa_oblag),0) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''n2'',''f1'',''f2'') and type_=''st'''+
             '    and code_nalog=3) '+     
             'where key_head='''+@key_head+''' and razdel=''1.2'' and kod_str=040'
    exec(@sql)
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(whole) - isnull(sum(summa_oblag),0) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''n2'',''f1'',''f2'') and type_=''st'''+
             '    and code_nalog=2) '+     
             'where key_head='''+@key_head+''' and razdel=''2'' and kod_str=030'
    exec(@sql)
    if @is_dop='1'
    begin
      set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(summa - summa_oblag) from #tmp_dop_vznos'+
             '  where mm='+@smm+
             '    and code_nalog=case when left(esss_2017_sums.kod_tarif,1)=''1'' then ''8'' else ''9'' end '+ 
             '    and n_stat=convert(int,right(esss_2017_sums.kod_tarif,2))) '+     
             'where key_head='''+@key_head+''' and razdel in (''1.31'',''1.32'') and kod_str=030'
      exec(@sql)
      set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(summa_oblag) from #tmp_dop_vznos'+
             '  where mm='+@smm+
             '    and code_nalog=case when left(esss_2017_sums.kod_tarif,1)=''1'' then ''8'' else ''9'' end '+ 
             '    and n_stat=convert(int,right(esss_2017_sums.kod_tarif,2))) '+     
             'where key_head='''+@key_head+''' and razdel in (''1.31'',''1.32'') and kod_str=040'
      exec(@sql)
   end

    --
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(summa_oblag) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''f1'',''f2'') and type_=''pr'''+
             '    and code_nalog=6) '+     
             'where key_head='''+@key_head+''' and razdel=''1.1'' and kod_str=051'
    exec(@sql)
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(summa_oblag) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''f1'',''f2'') and type_=''pr'''+
             '    and code_nalog=2) '+     
             'where key_head='''+@key_head+''' and razdel=''2'' and kod_str=040'
    exec(@sql)


    --
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(nalog) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''f1'',''f2'') and type_=''st'''+
             '    and code_nalog=6) '+     
             'where key_head='''+@key_head+''' and razdel=''1.1'' and kod_str=060'
    exec(@sql)
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(nalog) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''f1'',''f2'') and type_=''st'''+
             '    and code_nalog=3) '+     
             'where key_head='''+@key_head+''' and razdel=''1.2'' and kod_str=060'
    exec(@sql)
    if @is_dop='1'
    begin
      set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(nalog) from #tmp_dop_vznos'+
             '  where mm='+@smm+
             '    and code_nalog=case when left(esss_2017_sums.kod_tarif,1)=''1'' then ''8'' else ''9'' end '+ 
             '    and n_stat=convert(int,right(esss_2017_sums.kod_tarif,2))) '+     
             'where key_head='''+@key_head+''' and razdel in (''1.31'',''1.32'') and kod_str=050'
      exec(@sql)
   end

--    set @sql='update esss_2017_sums set '+@col+'=('+
--             '  select sum(nalog) from #tmp_results'+
--             '  where mm='+@smm+' and scale_code in (''n1'',''f1'',''f2'') and type_=''st'''+
--             '    and code_nalog=2) '+     
--             'where key_head='''+@key_head+''' and razdel=''2'' and kod_str=060'
--    exec(@sql)


    --  
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(nalog) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''f1'',''f2'') and type_=''pr'''+
             '    and code_nalog=6) '+     
             'where key_head='''+@key_head+''' and razdel=''1.1'' and kod_str=062'
    exec(@sql)

    --
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(kolvo) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''f1'',''f2'') and type_=''st'''+
             '    and code_nalog=6) '+     
             'where key_head='''+@key_head+''' and razdel=''1.1'' and kod_str=020'
    exec(@sql)
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(kolvo) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''f1'',''f2'') and type_=''st'''+
             '    and code_nalog=3) '+     
             'where key_head='''+@key_head+''' and razdel=''1.2'' and kod_str=020'
    exec(@sql)
    if @is_dop='1'
    begin
      set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(kolvo) from #tmp_dop_vznos'+
             '  where mm='+@smm+
             '    and code_nalog=case when left(esss_2017_sums.kod_tarif,1)=''1'' then ''8'' else ''9'' end '+ 
             '    and n_stat=convert(int,right(esss_2017_sums.kod_tarif,2))) '+     
             'where key_head='''+@key_head+''' and razdel in (''1.31'',''1.32'') and kod_str=010'
      exec(@sql)
   end

    -- 
    set @sql='update esss_2017_sums set '+@col+'=('+
             '  select sum(kolvo) from #tmp_results'+
             '  where mm='+@smm+' and scale_code in (''n1'',''f1'',''f2'') and type_=''pr'''+
             '    and code_nalog=6) '+     
             'where key_head='''+@key_head+''' and razdel=''1.1'' and kod_str=021'
    exec(@sql)

    set @i=@i+1
  end

-- "" ( 3 )
if @is_dop='1'
  update esss_2017_sums set vsego=isnull((
    select sum(kolvo) from #tmp_dop_vznos
    where mm=-100
     and code_nalog=case when left(esss_2017_sums.kod_tarif,1)='1' then '8' else '9' end  
     and n_stat=convert(int,right(esss_2017_sums.kod_tarif,2))
  ),0)      
  where key_head=@key_head and razdel in ('1.31','1.32') and kod_str='010'


update esss_2017_sums set vsego=(
   select count(distinct pers_id) from #tmp_arhiv_social
   where mm between @end_mm-2 and @end_mm
     and code_nalog=6 and nalog<>0
)      
where key_head=@key_head and razdel='1.1' and kod_str='020'

update esss_2017_sums set vsego=(
  select sum(kolvo) from #tmp_results
  where mm=-100 and scale_code in ('n1','f1','f2') and type_='pr'
    and code_nalog='6')     
where key_head=@key_head and razdel='1.1' and kod_str='021'


update esss_2017_sums set vsego=(
   select count(distinct pers_id) from #tmp_arhiv_social
   where mm between @end_mm-2 and @end_mm
      and code_nalog=3 and nalog<>0
)      
where key_head=@key_head and razdel='1.2' and kod_str='020'


-- 
--50 = 30 - 40   1.1  1.2
update esss_2017_sums set esss_2017_sums.vsego_rp=isnull(t1.vsego_rp,0)-isnull(t2.vsego_rp,0), esss_2017_sums.mm1=isnull(t1.mm1,0)-isnull(t2.mm1,0),
                         esss_2017_sums.mm2=isnull(t1.mm2,0)-isnull(t2.mm2,0), esss_2017_sums.mm3=isnull(t1.mm3,0)-isnull(t2.mm3,0)
from 
  (select vsego_rp,mm1,mm2,mm3 from esss_2017_sums where key_head=@key_head and kod_str='030' and razdel='1.1') t1,
  (select vsego_rp,mm1,mm2,mm3 from esss_2017_sums where key_head=@key_head and kod_str='040' and razdel='1.1') t2
where key_head=@key_head and kod_str='050' and razdel='1.1'

update esss_2017_sums set esss_2017_sums.vsego_rp=isnull(t1.vsego_rp,0)-isnull(t2.vsego_rp,0), esss_2017_sums.mm1=isnull(t1.mm1,0)-isnull(t2.mm1,0),
                         esss_2017_sums.mm2=isnull(t1.mm2,0)-isnull(t2.mm2,0), esss_2017_sums.mm3=isnull(t1.mm3,0)-isnull(t2.mm3,0)
from 
  (select vsego_rp,mm1,mm2,mm3 from esss_2017_sums where key_head=@key_head and kod_str='030' and razdel='1.2') t1,
  (select vsego_rp,mm1,mm2,mm3 from esss_2017_sums where key_head=@key_head and kod_str='040' and razdel='1.2') t2
where key_head=@key_head and kod_str='050' and razdel='1.2'

--50 = 20 - 30 - 40   2
update esss_2017_sums set esss_2017_sums.vsego_rp=isnull(t1.vsego_rp,0)-isnull(t2.vsego_rp,0)-isnull(t3.vsego_rp,0),
                          esss_2017_sums.mm1=isnull(t1.mm1,0)-isnull(t2.mm1,0)-isnull(t3.mm1,0),
                          esss_2017_sums.mm2=isnull(t1.mm2,0)-isnull(t2.mm2,0)-isnull(t3.mm2,0), 
                          esss_2017_sums.mm3=isnull(t1.mm3,0)-isnull(t2.mm3,0)-isnull(t3.mm3,0)
from 
  (select vsego_rp,mm1,mm2,mm3 from esss_2017_sums where key_head=@key_head and kod_str='020' and razdel='2') t1,
  (select vsego_rp,mm1,mm2,mm3 from esss_2017_sums where key_head=@key_head and kod_str='030' and razdel='2') t2,
  (select vsego_rp,mm1,mm2,mm3 from esss_2017_sums where key_head=@key_head and kod_str='040' and razdel='2') t3
where key_head=@key_head and kod_str='050' and razdel='2'

--61 = 60 - 62   1.1
update esss_2017_sums set esss_2017_sums.vsego_rp=isnull(t1.vsego_rp,0)-isnull(t2.vsego_rp,0), esss_2017_sums.mm1=isnull(t1.mm1,0)-isnull(t2.mm1,0),
                         esss_2017_sums.mm2=isnull(t1.mm2,0)-isnull(t2.mm2,0), esss_2017_sums.mm3=isnull(t1.mm3,0)-isnull(t2.mm3,0)
from 
  (select vsego_rp,mm1,mm2,mm3 from esss_2017_sums where key_head=@key_head and kod_str='060' and razdel='1.1') t1,
  (select vsego_rp,mm1,mm2,mm3 from esss_2017_sums where key_head=@key_head and kod_str='062' and razdel='1.1') t2
where key_head=@key_head and kod_str='061' and razdel='1.1'


--   1
insert esss_2017_sums (key_head, kbk, kod_str, razdel, kod_tarif, vsego_rp, mm1,mm2,mm3)
select @key_head,'18210202131061010160','060','1','10', sum(vsego_rp), sum(mm1),sum(mm2),sum(mm3)
from esss_2017_sums where key_head=@key_head 
  and razdel='1.31' and kod_str='050' and kod_tarif='121'

insert esss_2017_sums (key_head, kbk, kod_str, razdel, kod_tarif, vsego_rp, mm1,mm2,mm3)
select @key_head,'18210202131061020160','060','1','11', sum(vsego_rp), sum(mm1),sum(mm2),sum(mm3)
from esss_2017_sums where key_head=@key_head 
  and razdel='1.32' and kod_str='050' and left(kod_tarif,1)='1'

insert esss_2017_sums (key_head, kbk, kod_str, razdel, kod_tarif, vsego_rp, mm1,mm2,mm3)
select @key_head,'18210202132061010160','060','1','20', sum(vsego_rp), sum(mm1),sum(mm2),sum(mm3)
from esss_2017_sums where key_head=@key_head 
  and razdel='1.31' and kod_str='050' and kod_tarif='222'

insert esss_2017_sums (key_head, kbk, kod_str, razdel, kod_tarif, vsego_rp, mm1,mm2,mm3)
select @key_head,'18210202132061020160','060','1','21', sum(vsego_rp), sum(mm1),sum(mm2),sum(mm3)
from esss_2017_sums where key_head=@key_head 
  and razdel='1.32' and kod_str='050' and left(kod_tarif,1)='2'

delete from esss_2017_sums where key_head=@key_head and razdel='1' and kod_str='060'
  and isnull(mm1,0)=0 and isnull(mm2,0)=0 and isnull(mm3,0)=0 and isnull(vsego_rp,0)=0

if not exists(select 1 from esss_2017_sums where key_head=@key_head and razdel='1' and kod_str='060')
  insert esss_2017_sums (key_head, kbk, kod_str, razdel, kod_tarif, vsego_rp, mm1,mm2,mm3)
  values (@key_head,'','060','1','00', 0, 0, 0, 0)

--if not exists(select 1 from esss_2017_sums where key_head=@key_head and razdel='1' and kod_str='060')
--  insert esss_2017_sums (key_head, kbk, kod_str, razdel, kod_tarif, vsego_rp, mm1,mm2,mm3)
--  values (@key_head,'','060','1','00', 0, 0, 0, 0)


--. 3  4  
update #tmp_fss set kod_str='020' 
where kod_str='010' and razd='3'
  and pid in (select pers_id from esss_inostr)
 
insert #tmp_fss(pid, razd, x_ind, sum_, dni_, kod_str)
select pid,'3', x_ind, sum_, dni_, '011'
from #tmp_fss where kod_str='010'
  and pid in (select pers_id from const where fl_sovmest='1')

insert #tmp_fss(pid,razd, x_ind, sum_, dni_, kod_str)
select pid,'3', x_ind, sum_, dni_, '021'
from #tmp_fss where kod_str='020'
  and pid in (select pers_id from const where fl_sovmest='1')

insert #tmp_fss(pid,razd, x_ind, sum_, dni_, kod_str)
select pid,'3', x_ind, sum_, dni_, '031'
from #tmp_fss where kod_str='030'
  and pid in (select pers_id from const where fl_sovmest='1')

--   ..         
insert #tmp_fss(pid,razd, x_ind, sum_, dni_, kod_str)
select null, t1.rd_, null,0,0,t1.str_
from (
  select '3' as rd_, '010' as str_  union
  select '3', '011'  union
  select '3', '020'  union
  select '3', '021'  union
  select '3', '030'  union
  select '3', '031'  union
  select '3', '040'  union
  select '3', '050'  union
  select '3', '061'  union
  select '3', '062'  union
  select '3', '070'  union
  select '3', '090'  union
  select '4c', '020'  union
  select '4c', '030'  union
  select '4c', '050'  union
  select '4c', '060'  union
  select '4m', '020'  union
  select '4m', '030'  union
  select '4m', '050'  union
  select '4m', '060'  union
  select '4p', '020'  union
  select '4r', '020'  union
  select '4r', '030'  union
  select '4r', '050'  union
  select '4r', '060'  union
  select '4s', '020'  union
  select '4s', '030'
) t1

--      ,    - "-"
--     = 
insert esss_2017_fss(key_head, razdel, kod_str, n_sl, days, rashod, rashod_fb)
select @key_head, razd, kod_str,count(distinct x_ind), 
       case when kod_str in ('061','062') 
            then count(distinct pers_mm) 
            else case when kod_str in ('040','050') 
                      then count(distinct x_ind) 
                      else sum(dni_)
                 end 
       end,
       sum(sum_), 0
from #tmp_fss
group by razd, kod_str

insert esss_2017_fss(key_head, razdel, kod_str, n_sl, days, rashod, rashod_fb)
select @key_head, '3', '080', 0, 0, sum(nalog), 0
from #tmp_arhiv_social where code in (select code from sprav where tip_esss='fi')

update esss_2017_fss set rashod_fb=rashod, rashod=0
where key_head=@key_head and 
  (left(razdel,1)='4' or  razdel='3' and kod_str in ('070','080'))

update esss_2017_fss set rashod_fb=isnull(t1.rash_fb,0)
from (
   select kod_str as k_str, sum(rashod_fb) as rash_fb from esss_2017_fss t1
   where key_head=@key_head and left(t1.razdel,1)='4' 
   group by kod_str
) t1
where key_head=@key_head and razdel='3'
  and kod_str=case t1.k_str when '020' then '010' when '030' then '030' 
     when '050' then '061' when '060' then '062' else '' 
  end 

update esss_2017_fss set rashod=isnull(rashod,0)+isnull(rashod_fb,0)
where key_head=@key_head 

--      .4
insert esss_2017_fss(key_head, razdel, kod_str, n_sl, days, rashod, rashod_fb)
select @key_head, razdel, '010', sum(n_sl), sum(days), sum(rashod), sum(rashod_fb)
from esss_2017_fss where key_head=@key_head and left(razdel,1)='4'
group by razdel

insert esss_2017_fss(key_head, razdel, kod_str, n_sl, days, rashod, rashod_fb)
select @key_head, razdel, '040', sum(n_sl), sum(days), sum(rashod), sum(rashod_fb)
from esss_2017_fss where key_head=@key_head and left(razdel,1)='4' and kod_str in ('050','060')
group by razdel

--   . 4
insert esss_2017_fss(key_head, razdel, kod_str, n_sl, days, rashod, rashod_fb)
select @key_head, '4z', kod_str, sum(n_sl), sum(days), sum(rashod), sum(rashod_fb)
from esss_2017_fss where key_head=@key_head and left(razdel,1)='4'
group by kod_str

--  -     4, .     
insert esss_2017_fss(key_head, razdel, kod_str, n_sl, days, rashod, rashod_fb)
select @key_head, '4z', kod_str, n_sl, days, rashod, rashod_fb
from esss_2017_fss where key_head=@key_head and razdel='3' and kod_str in ('070','080')


--  . 3
insert esss_2017_fss(key_head, razdel, kod_str, n_sl, days, rashod, rashod_fb)
select @key_head, '3', '060', sum(n_sl), sum(days), sum(rashod), sum(rashod_fb)
from esss_2017_fss where key_head=@key_head and razdel='3' and kod_str in ('061','062')

insert esss_2017_fss(key_head, razdel, kod_str, n_sl, days, rashod, rashod_fb)
select @key_head, '3', '100', sum(n_sl), sum(days), sum(rashod), sum(rashod_fb)
from esss_2017_fss where key_head=@key_head and razdel='3'
  and kod_str in ('010','020','030','040','050','060','070','080','090')

insert esss_2017_fss(key_head, razdel, kod_str, n_sl, days, rashod, rashod_fb)
values (@key_head, '3','110',0, 0,0, 0)


drop table #tmp_fss

--
  update esss_2017_sums set vsego_rp=isnull(vsego_rp,0), mm1=isnull(mm1,0),
                            mm2=isnull(mm2,0), mm3=isnull(mm3,0)
  where key_head=@key_head

  update esss_2017_sums set vsego=mm1 + mm2 + mm3
  where key_head=@key_head and vsego is null

  if (select vsego_rp from esss_2017_sums where key_head=@key_head and razdel='1' and kod_str='120')>0
     update esss_2017_sums set vsego_rp=2 where key_head=@key_head and razdel='2' and kod_str='100'
  if (select vsego from esss_2017_sums where key_head=@key_head and razdel='1' and kod_str='120')>0
     update esss_2017_sums set vsego=2 where key_head=@key_head and razdel='2' and kod_str='100'
  if (select mm1 from esss_2017_sums where key_head=@key_head and razdel='1' and kod_str='120')>0
     update esss_2017_sums set mm1=2 where key_head=@key_head and razdel='2' and kod_str='100'
  if (select mm2 from esss_2017_sums where key_head=@key_head and razdel='1' and kod_str='120')>0
     update esss_2017_sums set mm2=2 where key_head=@key_head and razdel='2' and kod_str='100'
  if (select mm3 from esss_2017_sums where key_head=@key_head and razdel='1' and kod_str='120')>0
     update esss_2017_sums set mm3=2 where key_head=@key_head and razdel='2' and kod_str='100'

  update esss_2017_fss set n_sl=isnull(n_sl,0), days=isnull(days,0),
                            rashod=isnull(rashod,0), rashod_fb=isnull(rashod_fb,0)
  where key_head=@key_head

  -- . 
  exec dbo.sp_pers_ess @key_head, @kf
go
grant execute on sp_esss_2017 to AitUsers
go
--exec sp_esss_2017 '1', 1, 3, 2017, 'w_nlg_9', 'qwe1'
--select * from esss_2017_head
--select * from esss_2017_sums
--select * from esss_2017_fss
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'sec_name' and ( status & 0x08 ) = 0 
    and id = ( select id from sysobjects where name = 'pers_ess' )
if isnull(@l,0) <> 0 
begin
   ALTER TABLE pers_ess alter column sec_name varchar(60) null
end
go