set QUOTED_IDENTIFIER off
go
set ARITHABORT off
go


if not exists (select 1 from sysobjects where name = 'tbl_esn_codes')
create table tbl_esn_codes (
  code_nalog char(1) not null,
  name_nalog varchar(25) not null,
  yy_begin int not null,
  yy_end int not null
)
go

if not exists (select * from tbl_esn_codes where code_nalog='1')
  insert tbl_esn_codes(code_nalog,name_nalog,yy_begin,yy_end)
  values('1',' ',2000,2009)
go
if not exists (select * from tbl_esn_codes where code_nalog='2')
  insert tbl_esn_codes(code_nalog,name_nalog,yy_begin,yy_end)
  values('2','',2000,2050)
go
if not exists (select * from tbl_esn_codes where code_nalog='3')
  insert tbl_esn_codes(code_nalog,name_nalog,yy_begin,yy_end)
  values('3','',2000,2050)
go
if not exists (select * from tbl_esn_codes where code_nalog='4')
  insert tbl_esn_codes(code_nalog,name_nalog,yy_begin,yy_end)
  values('4','',2000,2011)
go
--if not exists (select * from tbl_esn_codes where code_nalog='5')
--  insert tbl_esn_codes(code_nalog,name_nalog,yy_begin,yy_end)
--  values('5','. . ',2013,2050)
delete from tbl_esn_codes where code_nalog='5'
go
if not exists (select * from tbl_esn_codes where code_nalog='6')
  insert tbl_esn_codes(code_nalog,name_nalog,yy_begin,yy_end)
  values('6',' ',2000,2050)
go
if not exists (select * from tbl_esn_codes where code_nalog='7')
  insert tbl_esn_codes(code_nalog,name_nalog,yy_begin,yy_end)
  values('7',' ',2000,2050)
go
if not exists (select * from tbl_esn_codes where code_nalog='8')
  insert tbl_esn_codes(code_nalog,name_nalog,yy_begin,yy_end)
  values('8','.  ( 1)',2013,2050)
go
if not exists (select * from tbl_esn_codes where code_nalog='9')
  insert tbl_esn_codes(code_nalog,name_nalog,yy_begin,yy_end)
  values('9','.  ( 2)',2013,2050)
go

if not exists(select 1 from syscolumns where id = object_id('constn') and name = 'd_min_bl')
begin
   alter table constn add d_min_bl int null
end
go
if not exists(select 1 from syscolumns where id = object_id('sprav') and name = 'fl_dmin_bl')
begin
   alter table sprav add fl_dmin_bl char(1) null
end
go

delete from table_nalog_soc where yy=2013 and code_nalog = '5'
go
Declare @l int,@val char(1)
set @val='0'
select @l = count(*) from arhiv_social where code_nalog='5' 
  and yy=2013 and nalog<>0

if @l>0
begin
  set @val='1'
  update arhiv_social set code_nalog='8' where code_nalog='5'
    and yy=2013 and procent=4
  update arhiv_social set code_nalog='9' where code_nalog='5'
    and yy=2013 and procent=2
  update arhiv_social_fond set code_nalog='8' where code_nalog='5'
    and yy=2013 and procent=4
  update arhiv_social_fond set code_nalog='9' where code_nalog='5'
    and yy=2013 and procent=2
end
select @l = count(mode_id) from cfg_reg_values where app_id = 1 and mode_id = 'w_ras_dw' and param_id = 'vred_tarif'
if @l = 0
begin
  insert into cfg_reg_values (app_id, mode_id, param_id, value_f) 
  values (1,'w_ras_dw','vred_tarif',@val)
end
select @l = count(mode_id) from cfg_reg_params where app_id = 1 and mode_id = 'w_ras_dw' and param_id = 'vred_tarif'
if @l = 0
begin
  insert into cfg_reg_params (app_id, mode_id, param_id, name_f, type_f, sql_f, default_f)
  values (1,'w_ras_dw','vred_tarif', '. .   ', 'ch', '', @val)
end
go

if not exists(select 1 from syscolumns where id = object_id('dolsn') and name = 'usl_truda')
begin
   alter table dolsn add usl_truda varchar(8) null
end
go
if not exists(select 1 from syscolumns where id = object_id('dolsn') and name = 'kod_pos_spis')
begin
   alter table dolsn add kod_pos_spis varchar(25) null
end
go
if not exists(select 1 from syscolumns where id = object_id('pf_condition') and name = 'nomer_spis')
begin
   alter table pf_condition add nomer_spis int null
end
go

if not exists(select 1 from syscolumns where id = object_id('spravka_doh_bl') and name = 'd_min')
begin
   alter table spravka_doh_bl add d_min int null
end
go

if not exists(select 1 from sysobjects where name = 'table_nalog_dop')
  create table table_nalog_dop(
    yy int not null primary key,
    prc1 decimal(4,2) null,
    prc2 decimal(4,2) null
  )
go
if not exists(select 1 from table_nalog_dop where yy=2013)
  insert into table_nalog_dop(yy,prc1,prc2)
  values (2013, 4, 2)
go

if not exists(select 1 from syscolumns where id = object_id('y_jur_dot') and name = 'c_user')
begin
   alter table y_jur_dot add c_user int null
end
go
if not exists(select 1 from syscolumns where id = object_id('arhiv_ras') and name = 'n_spis')
begin
   alter table arhiv_ras add n_spis int null
end
go

if not exists(select 1 from syscolumns where id = object_id('ust') and name = 'zp_patch')
begin
   alter table ust add zp_patch varchar(20) null
end
go

declare @zp varchar(50)
select @zp=zp_patch from ust where key_f='1'
if @zp is null or @zp<'7.9.4.3'
begin
  update fin_oper set fl_social='' where fl_social='9'
end
go

if not exists(select 1 from syscolumns where id = object_id('scale_comments') and name = 'cat_pf')
begin
   alter table scale_comments add cat_pf varchar(10) null
end
go

if not exists (select * from rsv_tags where yy = '2013')
begin
  select * into #tags from rsv_tags
  update #tags set yy = '2013'
  insert into rsv_tags select * from #tags
  drop table #tags
end
go

if not exists(select 1 from syscolumns where id = object_id('constn_other') and name = 'd_min_bl')
begin
   alter table constn_other add d_min_bl int null
end
go
if not exists(select 1 from syscolumns where id = object_id('constn_current') and name = 'd_min_bl')
begin
   alter table constn_current add d_min_bl int null
end
go

/*     */
if not exists (select * from sysobjects where name='sp_qualificationcategory')
begin
	create table sp_qualificationcategory (
		id_ int not null,
		name_ varchar (50) null,
		PRIMARY KEY (id_))
end 
go

grant insert, select, update,delete, references on sp_qualificationcategory to AitUsers
go

Declare @l int
SELECT @l = count(*) from sp_qualificationcategory
if @l=0
begin
	INSERT INTO sp_qualificationcategory VALUES (1, '')
	INSERT INTO sp_qualificationcategory VALUES (2, '')
	INSERT INTO sp_qualificationcategory VALUES (7, '')
	INSERT INTO sp_qualificationcategory VALUES (999, ' ')
end
go

if not exists (select * from sysobjects where name='sp_speciality')
begin
	create table sp_speciality (
		id_ int not null,
		name_ varchar (200) null,
		parent int not null,
		PRIMARY KEY (id_))
end 
go

grant insert, select, update,delete, references on sp_speciality to AitUsers
go

Declare @l int
SELECT @l = count(*) from sp_speciality
if @l=0
begin
	INSERT INTO sp_speciality VALUES (15, '', 1 )
	INSERT INTO sp_speciality VALUES (16, '', 1)
	INSERT INTO sp_speciality VALUES (17, '', 2 )
	INSERT INTO sp_speciality VALUES (18, '-', 2 )
	INSERT INTO sp_speciality VALUES (19, '   ', 2 )
	INSERT INTO sp_speciality VALUES (20, '', 3 )
	INSERT INTO sp_speciality VALUES (21, '', 4 )
	INSERT INTO sp_speciality VALUES (22, ' ', 4 )
	INSERT INTO sp_speciality VALUES (23, '    ', 4 )
	INSERT INTO sp_speciality VALUES (24, '', 5 )
	INSERT INTO sp_speciality VALUES (25, ' ', 5 )
	INSERT INTO sp_speciality VALUES (26, '    ', 5 )
	INSERT INTO sp_speciality VALUES (27, ' ', 6 )
	INSERT INTO sp_speciality VALUES (28, '  ', 6 )
	INSERT INTO sp_speciality VALUES (29, ' ', 7 )
	INSERT INTO sp_speciality VALUES (30, '    ', 7 )
	INSERT INTO sp_speciality VALUES (31, '', 8)
	INSERT INTO sp_speciality VALUES (32, '', 8 )
	INSERT INTO sp_speciality VALUES (33, '   ', 8 )
	INSERT INTO sp_speciality VALUES (34, '', 9)
	INSERT INTO sp_speciality VALUES (35, ' ', 9 )
	INSERT INTO sp_speciality VALUES (36, '    ', 9 )
	INSERT INTO sp_speciality VALUES (37, '  ', 10)
	INSERT INTO sp_speciality VALUES (38, ' ', 10 )
	INSERT INTO sp_speciality VALUES (39, '-', 11 )
	INSERT INTO sp_speciality VALUES (40, ' -', 11 )
	INSERT INTO sp_speciality VALUES (41, '-', 12)
	INSERT INTO sp_speciality VALUES (42, '-', 13 )
	INSERT INTO sp_speciality VALUES (43, '-', 14 )
	INSERT INTO sp_speciality VALUES (45, '', 44 )
	INSERT INTO sp_speciality VALUES (46, '    ', 44)
	INSERT INTO sp_speciality VALUES (47, '', 44 )
	INSERT INTO sp_speciality VALUES (48, '', 44 )
	INSERT INTO sp_speciality VALUES (49, '   ', 44 )
	INSERT INTO sp_speciality VALUES (50, '', 44 )
	INSERT INTO sp_speciality VALUES (51, '', 44 )
	INSERT INTO sp_speciality VALUES (52, '', 44 )
	INSERT INTO sp_speciality VALUES (53, '', 44 )
	INSERT INTO sp_speciality VALUES (54, ' ', 44 )
	INSERT INTO sp_speciality VALUES (55, '', 44 )
	INSERT INTO sp_speciality VALUES (56, ' ', 44 )
	INSERT INTO sp_speciality VALUES (57, '', 44 )
	INSERT INTO sp_speciality VALUES (58, '', 44)
	INSERT INTO sp_speciality VALUES (1, ' ', 0)
	INSERT INTO sp_speciality VALUES (2, ' ', 0)
	INSERT INTO sp_speciality VALUES (3, '', 0)
	INSERT INTO sp_speciality VALUES (4, '- ', 0)
	INSERT INTO sp_speciality VALUES (5, '', 0)
	INSERT INTO sp_speciality VALUES (6, ' ', 0)
	INSERT INTO sp_speciality VALUES (7, ' ', 0)
	INSERT INTO sp_speciality VALUES (8, '', 0)
	INSERT INTO sp_speciality VALUES (9, ' ', 0)
	INSERT INTO sp_speciality VALUES (10, ' ', 0)
	INSERT INTO sp_speciality VALUES (11, ' ', 0)
	INSERT INTO sp_speciality VALUES (12, ' ', 0)
	INSERT INTO sp_speciality VALUES (13, ' ', 0)
	INSERT INTO sp_speciality VALUES (14, ' ', 0)
	INSERT INTO sp_speciality VALUES (44, ' ', 0)
end
go

if not exists (select * from sysobjects where name='sp_position')
begin
	create table sp_position (
		id_ int not null,
		name_ varchar (200) null,
		PRIMARY KEY (id_))
end 
go

grant insert, select, update,delete, references on sp_position to AitUsers
go

Declare @l int
SELECT @l = count(*) from sp_position
if @l=0
begin
	INSERT INTO sp_position VALUES (1, '')
	INSERT INTO sp_position VALUES (2, ' ')
	INSERT INTO sp_position VALUES (3, ' ')
	INSERT INTO sp_position VALUES (4, ' ')
	INSERT INTO sp_position VALUES (5, '')
	INSERT INTO sp_position VALUES (6, '')
	INSERT INTO sp_position VALUES (7, '- ')
	INSERT INTO sp_position VALUES (8, '- ')
	INSERT INTO sp_position VALUES (9, ' ')
	INSERT INTO sp_position VALUES (10, '- ')
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'speciality_med' 
    and id = ( select id from sysobjects where name = 'dolsn' )
if @l = 0
begin
  ALTER TABLE dolsn ADD speciality_med integer NULL
end
go
grant insert, select, update,delete, references on dolsn to AitUsers
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'med_qual_cat' 
    and id = ( select id from sysobjects where name = 'constik' )
if @l = 0
begin
  ALTER TABLE constik ADD med_qual_cat integer NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'med_vid_dolz' 
    and id = ( select id from sysobjects where name = 'constik' )
if @l = 0
begin
  ALTER TABLE constik ADD med_vid_dolz integer NULL
end
go
grant insert, select, update,delete, references on constik to AitUsers
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'med_vid_doh' 
    and id = ( select id from sysobjects where name = 'sprav' )
if @l = 0
begin
  ALTER TABLE sprav ADD med_vid_doh integer NULL
end
go
grant insert, select, update,delete, references on sprav to AitUsers
go
/*      */

delete from cfg_reg_params where app_id=1 
  and mode_id ='SOC_NALOG' and param_id='round_months'
delete from cfg_reg_values where app_id=1 
  and mode_id ='SOC_NALOG' and param_id='round_months'
go

if not exists (select * from sysobjects where name='sp_qualificationcategory')
begin
	create table sp_qualificationcategory (
		id_ int not null,
		name_ varchar (50) null,
		PRIMARY KEY (id_))
end 
go
grant insert, select, update,delete, references on sp_qualificationcategory to AitUsers
go

Declare @l int
select @l = count(mode_id) from cfg_reg_modes where app_id = 1 and mode_id = 'zp_med'
if @l = 0
  insert into cfg_reg_modes (app_id, mode_id, code_f, name_f) 
  values (1,'zp_med','','')
go
Declare @l int
select @l = count(param_id) from cfg_reg_params where app_id = 1 and mode_id = 'zp_med' and param_id = 'med_vkl'
if @l = 0
  insert into cfg_reg_params (app_id, mode_id, param_id, name_f, type_f, sql_f, default_f)
  values (1,'zp_med','med_vkl', '  ', 'ch', '', '0')
go
Declare @l int
select @l = count(param_id) from cfg_reg_values where app_id = 1 and mode_id = 'zp_med' and param_id = 'med_vkl'
if @l = 0
  insert into cfg_reg_values (app_id, mode_id, param_id, value_f)
  values( 1, 'zp_med', 'med_vkl', '0')
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'nocount_days' 
    and id = ( select id from sysobjects where name = 'vari' )
if @l = 0
begin
  ALTER TABLE vari ADD nocount_days char(1) NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'fl_prc' 
    and id = ( select id from sysobjects where name = 'sp_vid_discounts' )
if @l = 0
begin
  ALTER TABLE sp_vid_discounts ADD fl_prc char(1) NULL
end
go
update sp_vid_discounts set fl_prc='0' where fl_prc is null
go

Declare @l int
select @l = count(param_id) from cfg_reg_params where app_id = 1 and mode_id = 'PERS_CART' and param_id = 'jur_konst'
if @l = 0
  insert into cfg_reg_params (app_id, mode_id, param_id, name_f, type_f, sql_f, default_f)
  values (1,'PERS_CART','jur_konst', '  ', 'ch', '', '0')
go
Declare @l int
select @l = count(param_id) from cfg_reg_values where app_id = 1 and mode_id = 'PERS_CART' and param_id = 'jur_konst'
if @l = 0
  insert into cfg_reg_values (app_id, mode_id, param_id, value_f)
  values( 1, 'PERS_CART', 'jur_konst', '0')
go

if not exists (select * from sysobjects where name='jur_pers_konst')
begin
	create table jur_pers_konst (
            pers_id varchar(15) not null,
            id_konst tinyint not null, 
            mm tinyint not null,
            yy smallint not null,
            value_ decimal(16,4) null,  
		PRIMARY KEY (pers_id, id_konst, mm, yy)
        )
end 
go
grant insert, select, update,delete, references on jur_pers_konst to AitUsers
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'code_dopl1' 
    and id = ( select id from sysobjects where name = 'ust_alg' )
if @l = 0
begin
  ALTER TABLE ust_alg ADD code_dopl1 char(3) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'code_dopl2' 
    and id = ( select id from sysobjects where name = 'ust_alg' )
if @l = 0
begin
  ALTER TABLE ust_alg ADD code_dopl2 char(3) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'formul_dopl1' 
    and id = ( select id from sysobjects where name = 'ust_alg' )
if @l = 0
begin
  ALTER TABLE ust_alg ADD formul_dopl1 char(2) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'formul_dopl2' 
    and id = ( select id from sysobjects where name = 'ust_alg' )
if @l = 0
begin
  ALTER TABLE ust_alg ADD formul_dopl2 char(2) NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'oktmo' 
    and id = ( select id from sysobjects where name = 'ust_nlg' )
if @l = 0
begin
  ALTER TABLE ust_nlg ADD oktmo varchar(12) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'oktmo' 
    and id = ( select id from sysobjects where name = 'xcheck' )
if @l = 0
begin
  ALTER TABLE xcheck ADD oktmo varchar(12) NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'scale_nerez' 
    and id = ( select id from sysobjects where name = 'sp_vid_dohods' )
if @l = 0
begin
  ALTER TABLE sp_vid_dohods ADD scale_nerez int NULL
end
go
update sp_vid_dohods set id_scale=null where id_scale=0
update sp_vid_dohods set scale_nerez=id_scale where scale_nerez is null
  and id_scale is not null 
go

-- 
if not exists(select * from sysobjects where name='sp_vred_klass')
  create table sp_vred_klass(
     klass_num tinyint not null,
     brief_name varchar(6) null,
     klass_name varchar(100) null,
     primary key (klass_num)
  )
go
grant select, insert,update,delete on sp_vred_klass to AitUsers
go
if not exists(select * from sp_vred_klass)
begin
  insert sp_vred_klass(klass_num, klass_name, brief_name)
  values (31, '', '3.1')
  insert sp_vred_klass(klass_num, klass_name, brief_name)
  values (32, '', '3.2')
  insert sp_vred_klass(klass_num, klass_name, brief_name)
  values (33, '', '3.3')
  insert sp_vred_klass(klass_num, klass_name, brief_name)
  values (34, '', '3.4')
  insert sp_vred_klass(klass_num, klass_name, brief_name)
  values (4, '', '4')
end
go
delete from sp_vred_klass where klass_num in (1,2,21,22)
go

--.  
if not exists(select * from sysobjects where name='sp_vred_vznos')
  create table sp_vred_vznos(
     yy int not null,
     n_stat tinyint not null,
     prc decimal(5,2) null,
     code_nal char(1) null,
     primary key (yy,n_stat)
  )
go
grant select, insert,update,delete on sp_vred_vznos to AitUsers
go
if not exists(select * from sp_vred_vznos where yy=2013)
begin
  insert sp_vred_vznos(yy,n_stat,prc,code_nal)
  values (2013, 21, 4.00, '8')
  insert sp_vred_vznos(yy,n_stat,prc,code_nal)
  values (2013, 22, 2.00, '9')
end
if not exists(select * from sp_vred_vznos where yy=2014)
begin
--  insert sp_vred_vznos(yy,n_stat,prc,code_nal)
--  values (2014, 1, 0.00, '9')
--  insert sp_vred_vznos(yy,n_stat,prc,code_nal)
--  values (2014, 2, 0.00, '9')

  insert sp_vred_vznos(yy,n_stat,prc,code_nal)
  values (2014, 21, 6.00, '8')
  insert sp_vred_vznos(yy,n_stat,prc,code_nal)
  values (2014, 22, 4.00, '9')

  insert sp_vred_vznos(yy,n_stat,prc,code_nal)
  values (2014, 31, 2.00, '9')
  insert sp_vred_vznos(yy,n_stat,prc,code_nal)
  values (2014, 32, 4.00, '9')
  insert sp_vred_vznos(yy,n_stat,prc,code_nal)
  values (2014, 33, 6.00, '9')
  insert sp_vred_vznos(yy,n_stat,prc,code_nal)
  values (2014, 34, 7.00, '9')
  insert sp_vred_vznos(yy,n_stat,prc,code_nal)
  values (2014, 4, 8.00, '8')
end
go
delete from sp_vred_vznos where n_stat in (1,2)
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'n_stat' 
    and id = ( select id from sysobjects where name = 'arhiv_social' )
if @l = 0
begin
  ALTER TABLE arhiv_social ADD n_stat tinyint NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'n_stat' 
    and id = ( select id from sysobjects where name = 'soc_arhiv_ras' )
if @l = 0
begin
  ALTER TABLE soc_arhiv_ras ADD n_stat tinyint NULL
end
go

--   
declare @patch varchar(15)
select @patch=isnull(zp_patch,'') FROM ust WHERE key_f = '1'
if @patch<'8.0.3.2'
begin
--  update ras set ras.n_ras=xcheck.ymes*12 + xcheck.mes
--  from xcheck where ras.podr=xcheck.n_otd

--  update provod set plat=year*12 + mes

  update arhiv_social set n_stat=0 where yy<=2013 and code_nalog not in ('8','9')
  update arhiv_social set n_stat=22 where yy=2013 and code_nalog ='9'
  update arhiv_social set n_stat=21 where yy=2013 and code_nalog ='8'

  update pf_condition set nomer_spis=21 where nomer_spis=1
  update pf_condition set nomer_spis=22 where nomer_spis=2
end
go


Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'n_stat' 
    and id = ( select id from sysobjects where name = 'dolsn' )
if @l = 0
begin
  ALTER TABLE dolsn ADD n_stat tinyint NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'klass_vred'
    and id = ( select id from sysobjects where name = 'dolsn' )
if @l = 0
begin
  ALTER TABLE dolsn ADD klass_vred tinyint NULL
end
go

update dolsn set n_stat=case when nomer_spis in (21,4) then 1 else 2 end,
      klass_vred=case when nomer_spis in (31,32,33,34,4) then nomer_spis else null end
from pf_condition 
where usl_truda=kod and nomer_spis in (21,22,31,32,33,34,4)
  and n_stat is null and klass_vred is null
go


--    arhiv_social  
--   9    
if not exists (select * from syscolumns where name='key_id' and id=object_id('arhiv_social'))
begin
   alter table arhiv_social add key_id int not null identity(1,1)

	Declare @name char( 50 )
	select @name = sysobjects.name
	from sysobjects, sysconstraints
	where sysconstraints.constid = sysobjects.id 
		and sysobjects.parent_obj = 
		(select id from sysobjects where name ='arhiv_social')
		and sysobjects.xtype= 'PK' 
	IF @name >'' 
	begin 
		EXEC( 'ALTER TABLE arhiv_social DROP CONSTRAINT '+@name )
	end
end
GO
if not exists(select sysobjects.name
	from sysobjects, sysconstraints
	where sysconstraints.constid = sysobjects.id 
		and sysobjects.parent_obj = 
		(select id from sysobjects where name ='arhiv_social')
		and sysobjects.xtype= 'PK') 
begin
	ALTER TABLE [dbo].[arhiv_social] ADD  PRIMARY KEY   
	(
		[key_id]
	)  

        CREATE INDEX [idx_arhsoc_rkeyf] ON arhiv_social ([rkeyf])
end
GO

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'fl_man'
    and id = ( select id from sysobjects where name = 'provod' )
if @l = 0
begin
  ALTER TABLE provod ADD fl_man char(1) NULL
end
go

Declare @l int
select @l = count(mode_id) from cfg_reg_values where app_id = 1 and mode_id = 'otpusk' and param_id = 'code_peni'
if @l = 0
begin
  insert into cfg_reg_values (app_id, mode_id, param_id, value_f) 
  values (1,'otpusk','code_peni','000')
end
go
Declare @l int
select @l = count(mode_id) from cfg_reg_params where app_id = 1 and mode_id = 'otpusk' and param_id = 'code_peni'
if @l = 0
begin
  insert into cfg_reg_params (app_id, mode_id, param_id, name_f, type_f, sql_f, default_f)
  values (1,'otpusk','code_peni', '     . ','sl','','0')
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'tip_file' 
    and id = ( select id from sysobjects where name = 'forms' )
if @l = 0
begin
  ALTER TABLE forms ADD tip_file char(1) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'fl_arh' 
    and id = ( select id from sysobjects where name = 'forms' )
if @l = 0
begin
  ALTER TABLE forms ADD fl_arh char(1) NULL
end
go

update forms set tip_file='1' --
where tip_file is null and tip<>'' 
  and isnull(dot_name,'')=''

update forms set tip_file='2' --WORD
where tip_file is null and tip<>'' 
  and isnull(fl_excel,'0')<>'1' and dot_name>''

update forms set tip_file='4', tip='', nomer=convert(varchar(15),(
    select n_doc from ust_nlg where key_f='1'
  )) --XML NDFL
where tip_file is null and tip='' 

update forms set tip_file='3' --EXCEL
where tip_file is null 
go

declare @val varchar(15)
select @val=value_f from cfg_reg_values where app_id=1 and mode_id='PERS_CART' and param_id='move_sotr'
if rtrim(@val)<>'1' or @val is null
  update const set n_otd_zr=n_otd where n_otd_zr<>n_otd
go
-- 
if not exists(select * from sysobjects where name='tbl_zavis_nach')
  create table tbl_zavis_nach(
     parent_code char(3) not null,
     child_code char(3) not null,
     fl_time char(1) null,
     fl_prc char(1) null,
     fl_sum char(1) null,
     fl_doc char(1) null,
     fl_brv char(1) null,
     fl_podr char(1) null,
     fl_cat char(1) null,
     fl_ap char(1) null,
     prc_ decimal(6,2) null,
     sum_ decimal(16,2) null,
     comm_ varchar(20) null,
     primary key (parent_code,child_code)
  )
go
grant select, insert,update,delete on tbl_zavis_nach to AitUsers
go

Declare @l int
select @l = count(param_id) from  cfg_usr_params  where param_id = 'm_cb_additional' and mode_id = '. ' and app_id = 1 
if @l = 0
INSERT INTO cfg_usr_params ( param_id, mode_id, app_id, name_f,default_f )  
VALUES 	('m_cb_additional'  ,'. ',1,'  ','1' )
GO
Declare @l int
select @l = count(param_id) from  cfg_usr_values  where param_id = 'm_cb_additional' and mode_id = '. ' and app_id = 1 
if @l = 0
INSERT INTO cfg_usr_values ( app_id, param_id, mode_id, role_id,value_f )  
         select 1, 'm_cb_additional' ,'. ',role_id,'1' 
         from cfg_usr_roles where app_id=1
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'n_stat' 
    and id = ( select id from sysobjects where name = 'arhiv_social_fond' )
if @l = 0
begin
  ALTER TABLE arhiv_social_fond ADD n_stat tinyint NULL
end

GO

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 's_1' 
    and id = ( select id from sysobjects where name = 'x_journal_raschet' )
if @l = 0
begin
  ALTER TABLE x_journal_raschet ADD s_1 decimal(16,2) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 's_2' 
    and id = ( select id from sysobjects where name = 'x_journal_raschet' )
if @l = 0
begin
  ALTER TABLE x_journal_raschet ADD s_2 decimal(16,2) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 's_3' 
    and id = ( select id from sysobjects where name = 'x_journal_raschet' )
if @l = 0
begin
  ALTER TABLE x_journal_raschet ADD s_3 decimal(16,2) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'baza_fss' 
    and id = ( select id from sysobjects where name = 'x_journal_raschet' )
if @l = 0
begin
  ALTER TABLE x_journal_raschet ADD baza_fss decimal(16,2) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'skid_fss'
    and id = ( select id from sysobjects where name = 'x_journal_raschet' )
if @l = 0
begin
  ALTER TABLE x_journal_raschet ADD skid_fss decimal(16,2) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'd_min' 
    and id = ( select id from sysobjects where name = 'x_journal_raschet' )
if @l = 0
begin
  ALTER TABLE x_journal_raschet ADD d_min smallint NULL
end
go
  ALTER TABLE x_journal_raschet alter column d_add decimal(10,2) null
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'days_fss' 
    and id = ( select id from sysobjects where name = 'x_journal_detail' )
if @l = 0
begin
  ALTER TABLE x_journal_detail ADD days_fss smallint NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'is_mrot' 
    and id = ( select id from sysobjects where name = 'x_journal_detail' )
if @l = 0
begin
  ALTER TABLE x_journal_detail ADD is_mrot char(1) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'prc' 
    and id = ( select id from sysobjects where name = 'x_journal_detail' )
if @l = 0
begin
  ALTER TABLE x_journal_detail ADD prc smallint NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'posob_max'
    and id = ( select id from sysobjects where name = 'x_journal_detail' )
if @l = 0
begin
  ALTER TABLE x_journal_detail ADD posob_max decimal(16,4) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'posob_mrot' 
    and id = ( select id from sysobjects where name = 'x_journal_detail' )
if @l = 0
begin
  ALTER TABLE x_journal_detail ADD posob_mrot decimal(16,4) NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'nach_days_year' 
    and id = ( select id from sysobjects where name = 'x_journal' )
if @l = 0
begin
  ALTER TABLE x_journal ADD nach_days_year smallint NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'opl_days_year' 
    and id = ( select id from sysobjects where name = 'x_journal' )
if @l = 0
begin
  ALTER TABLE x_journal ADD opl_days_year smallint NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'stag_bl_days' 
    and id = ( select id from sysobjects where name = 'x_journal' )
if @l = 0
begin
  ALTER TABLE x_journal ADD stag_bl_days int NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'fl_new_print' 
    and id = ( select id from sysobjects where name = 'x_journal' )
if @l = 0
begin
  ALTER TABLE x_journal ADD fl_new_print char(1) NULL
end
go

update provod set plat='0' where isnumeric(plat)<>1
go
alter table provod alter column plat int null
go

update sprav set provod_code=null
where isnull(provod_code,'0') not in ('0','1')

update ras set is_prvd=(
  select rtrim(provod_code) from sprav where sprav.code=ras.code
)
update ras_fond set is_prvd=(
  select rtrim(provod_code) from sprav where sprav.code=ras_fond.code
)
go

if not exists(
  select 1 from INFORMATION_SCHEMA.COLUMNS
  where table_name='provod' and column_name='is_platinum'
    and data_type='tinyint'
)
begin
  update provod set is_platinum='0' where isnull(is_platinum,'')<>'1'

  alter table provod alter column is_platinum tinyint null 
  ALTER TABLE provod ADD CONSTRAINT DF_provod_platinum DEFAULT (0) FOR is_platinum

  create index idx_provod_platinum on provod (is_platinum, xcheck)
end
go

--    
if not exists(select * from sysobjects where name='ndfl_scales')
  create table ndfl_scales(
    id_sc tinyint not null primary key,
    n_pp tinyint not null
  )
go
grant select, insert,update,delete on ndfl_scales to AitUsers
go
if not exists(select 1 from ndfl_scales)
begin
  insert ndfl_scales(n_pp,id_sc)
  select 3, id_scale from sp_vid_dohods
  where code='1010' and id_scale>0

  insert ndfl_scales(n_pp,id_sc)
  select distinct 1, id_scale from table_nalog
  where yy=2015 and procent=13 
    and id_scale not in (select id_sc from ndfl_scales)

  insert ndfl_scales(n_pp,id_sc)
  select distinct 2, id_scale from table_nalog
  where yy=2015 and procent=30 

  insert ndfl_scales(n_pp,id_sc)
  select distinct 4, id_scale from table_nalog
  where yy=2015 and procent=35 

  insert ndfl_scales(n_pp,id_sc)
  select distinct 5, id_scale from table_nalog
  where yy=2015 and procent=15 
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'kod_1c' 
    and id = ( select id from sysobjects where name = 'ust' )
if @l = 0
begin
  ALTER TABLE ust ADD kod_1c varchar(20) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'kod_1c' 
    and id = ( select id from sysobjects where name = 'ust_filial' )
if @l = 0
begin
  ALTER TABLE ust_filial ADD kod_1c varchar(20) NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'kod_1c' 
    and id = ( select id from sysobjects where name = 'xcheck' )
if @l = 0
begin
  ALTER TABLE xcheck ADD kod_1c varchar(20) NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'sub_kod_1c' 
    and id = ( select id from sysobjects where name = 'category' )
if @l = 0
begin
  ALTER TABLE category ADD sub_kod_1c varchar(50) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'sub_val_1c' 
    and id = ( select id from sysobjects where name = 'category' )
if @l = 0
begin
  ALTER TABLE category ADD sub_val_1c varchar(50) NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'sub_kod_1c' 
    and id = ( select id from sysobjects where name = 'zatr' )
if @l = 0
begin
  ALTER TABLE zatr ADD sub_kod_1c varchar(50) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'sub_val_1c' 
    and id = ( select id from sysobjects where name = 'zatr' )
if @l = 0
begin
  ALTER TABLE zatr ADD sub_val_1c varchar(50) NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'sub_kod_1c' 
    and id = ( select id from sysobjects where name = 'sp_ap_detail' )
if @l = 0
begin
  ALTER TABLE sp_ap_detail ADD sub_kod_1c varchar(50) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'sub_val_1c' 
    and id = ( select id from sysobjects where name = 'sp_ap_detail' )
if @l = 0
begin
  ALTER TABLE sp_ap_detail ADD sub_val_1c varchar(50) NULL
end
go

Declare @l int
select @l = count(mode_id) from  cfg_usr_modes  where mode_id = 'setup_1c' and app_id = 1 
if @l = 0
INSERT INTO cfg_usr_modes ( mode_id, app_id, name_f )  
VALUES 	('setup_1c',1,'    1' )
GO
Declare @l int
select @l = count(param_id) from  cfg_usr_params  where param_id = '!mode' and mode_id = 'setup_1c' and app_id = 1 
if @l = 0
INSERT INTO cfg_usr_params ( param_id, mode_id, app_id, name_f,default_f )  
VALUES 	('!mode'  ,'setup_1c',1,'       1','1' )
GO
Declare @l int
select @l = count(param_id) from  cfg_usr_values  where param_id = '!mode' and mode_id = 'setup_1c' and app_id = 1 
if @l = 0
INSERT INTO cfg_usr_values ( app_id, param_id, mode_id, role_id,value_f )  
         select 1, '!mode' ,'setup_1c',role_id,'1' 
         from cfg_usr_roles where app_id=1
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'fl_alim_doc' 
    and id = ( select id from sysobjects where name = 'ust' )
if @l = 0
begin
  ALTER TABLE ust ADD fl_alim_doc char(1) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'fl_ssud_doc' 
    and id = ( select id from sysobjects where name = 'ust' )
if @l = 0
begin
  ALTER TABLE ust ADD fl_ssud_doc char(1) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'fl_strah_doc' 
    and id = ( select id from sysobjects where name = 'ust' )
if @l = 0
begin
  ALTER TABLE ust ADD fl_strah_doc char(1) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'fl_imvich_doc' 
    and id = ( select id from sysobjects where name = 'ust' )
if @l = 0
begin
  ALTER TABLE ust ADD fl_imvich_doc char(1) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'fl_detvich_doc' 
    and id = ( select id from sysobjects where name = 'ust' )
if @l = 0
begin
  ALTER TABLE ust ADD fl_detvich_doc char(1) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'fl_autovipl_doc' 
    and id = ( select id from sysobjects where name = 'ust' )
if @l = 0
begin
  ALTER TABLE ust ADD fl_autovipl_doc char(1) NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'key_doc' 
    and id = ( select id from sysobjects where name = 'arhiv_lgots' )
if @l = 0
begin
  ALTER TABLE arhiv_lgots ADD key_doc varchar(10) NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'fl_low_tarif' 
    and id = ( select id from sysobjects where name = 'rsv_1_2014' )
if @l = 0
begin
  ALTER TABLE rsv_1_2014 ADD fl_low_tarif char(1) NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'don_last_2014' 
    and id = ( select id from sysobjects where name = 'rsv_1_2014' )
if @l = 0
begin
  ALTER TABLE rsv_1_2014 ADD don_last_2014 decimal(15,2) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'don_last_str' 
    and id = ( select id from sysobjects where name = 'rsv_1_2014' )
if @l = 0
begin
  ALTER TABLE rsv_1_2014 ADD don_last_str decimal(15,2) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'don_last_nak' 
    and id = ( select id from sysobjects where name = 'rsv_1_2014' )
if @l = 0
begin
  ALTER TABLE rsv_1_2014 ADD don_last_nak decimal(15,2) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'don_last_sp1' 
    and id = ( select id from sysobjects where name = 'rsv_1_2014' )
if @l = 0
begin
  ALTER TABLE rsv_1_2014 ADD don_last_sp1 decimal(15,2) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'don_last_sp2' 
    and id = ( select id from sysobjects where name = 'rsv_1_2014' )
if @l = 0
begin
  ALTER TABLE rsv_1_2014 ADD don_last_sp2 decimal(15,2) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'don_last_oms' 
    and id = ( select id from sysobjects where name = 'rsv_1_2014' )
if @l = 0
begin
  ALTER TABLE rsv_1_2014 ADD don_last_oms decimal(15,2) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'don_last_pr_2014' 
    and id = ( select id from sysobjects where name = 'rsv_1_2014' )
if @l = 0
begin
  ALTER TABLE rsv_1_2014 ADD don_last_pr_2014 decimal(15,2) NULL
end
go
Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'don_last_pr_str' 
    and id = ( select id from sysobjects where name = 'rsv_1_2014' )
if @l = 0
begin
  ALTER TABLE rsv_1_2014 ADD don_last_pr_str decimal(15,2) NULL
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'fl_only_gpd' 
    and id = ( select id from sysobjects where name = 'const' )
if @l = 0
begin
  ALTER TABLE const ADD fl_only_gpd char(1) NULL
end
go

if not exists(select 1 from syscolumns where id = object_id('x_journal') and name = 'key_parent')
begin
   alter table x_journal add key_parent varchar(15) null
end
go
if not exists(select 1 from syscolumns where id = object_id('x_journal') and name = 'key_kdr')
begin
   alter table x_journal add key_kdr varchar(15) null
end
go
 
grant insert, select, update, delete on x_journal to AitUsers
go

Declare @name char( 50 )
select @name=constraint_name from information_schema.table_constraints
where table_name='win_position' and constraint_type='PRIMARY KEY'

IF isnull(@name,'')<>'' and @name<>'PK_win_position_2015' 
begin 
	EXEC( 'ALTER TABLE win_position DROP CONSTRAINT '+@name )
end
GO
if not exists(
  select * from information_schema.table_constraints
  where table_name='win_position' and constraint_type='PRIMARY KEY' 
       and constraint_name='PK_win_position_2015'
)
begin
        alter table win_position add constraint PK_win_position_2015 PRIMARY KEY NONCLUSTERED (user_id, win_name)
end 
go

alter table win_position alter column key_f smallint null
go

if not exists(select 1 from sprav where code='786')
  insert into sprav (code,codename)
  values ('786','  ')
go

if not exists(select * from sysobjects where name='uved_ndfl_nerez')
  create table uved_ndfl_nerez(
    pers_id varchar(15) not null,
    yy int not null,
    num varchar(15) null,
    date_ datetime null,
    kod_gni varchar(15) null,
    status_nlg tinyint null,
    primary key (pers_id,yy)
  )
go
grant select,insert,update,delete on uved_ndfl_nerez to AitUsers
go


if not exists (select * from forms where key_f='ndfl_2_new')
	insert into forms (key_f, nomer, name, tip, dot_name, file_, fl_excel, tip_file, fl_arh)
	values ('ndfl_2_new', '72', '-2 2015', '', '', 'ndfl_2', '1', 3, NULL)
go

if not exists(select 1 from syscolumns where id = object_id('arhiv_social') and name = 'summa_oblag_over')
begin
   alter table arhiv_social add summa_oblag_over decimal(16,2) null
end
go
if not exists(select 1 from syscolumns where id = object_id('arhiv_social') and name = 'nalog_over')
begin
   alter table arhiv_social add nalog_over decimal(16,5) null
end
go

if not exists(select 1 from syscolumns where id = object_id('arhiv_social_fond') and name = 'summa_oblag_over')
begin
   alter table arhiv_social_fond add summa_oblag_over decimal(16,2) null
end
go
if not exists(select 1 from syscolumns where id = object_id('arhiv_social_fond') and name = 'nalog_over')
begin
   alter table arhiv_social_fond add nalog_over decimal(16,5) null
end
go

if not exists (select * from forms where key_f='NDFL2_20151030')
	insert into forms (key_f, nomer, name, tip, dot_name, file_, fl_excel, tip_file, fl_arh)
	values ('NDFL2_20151030', '72', '-2 20151030', '', '', 'NDFL2_20151030', '1', 3, NULL)
go

if not exists (select * from forms where key_f='NDFL2_151030o')
	insert into forms (key_f, nomer, name, tip, dot_name, file_, fl_excel, tip_file, fl_arh)
	values ('NDFL2_151030o', '72', '-2 20151030 ', '', '', 'NDFL2_20151030_oktmo', '1', 3, NULL)
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'inn_inostr' 
    and id = ( select id from sysobjects where name = 'const' )
if @l = 0
begin
  ALTER TABLE const ADD inn_inostr varchar(20) NULL
end
go

if not exists (select 1 from sysobjects where name = 'sp_stat_nalog_plat')
create table sp_stat_nalog_plat (
  keyid int not null primary key,
  name_nalog varchar(100) null
)
go
grant insert, select, update, delete on sp_stat_nalog_plat to AitUsers
go

Declare @l int
SELECT @l = count(*) from sp_stat_nalog_plat
if @l=0
begin
	insert into sp_stat_nalog_plat (keyid,name_nalog ) values (1, '  ')
	insert into sp_stat_nalog_plat (keyid,name_nalog ) values (2, '  ')
	insert into sp_stat_nalog_plat (keyid,name_nalog ) values (3, '. .   ')
	insert into sp_stat_nalog_plat (keyid,name_nalog ) values (4, '. . .  .     ')
	insert into sp_stat_nalog_plat (keyid,name_nalog ) values (5, '  .    ')
	insert into sp_stat_nalog_plat (keyid,name_nalog ) values (6, '.   ')
end
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'status_nlg' 
    and id = ( select id from sysobjects where name = 'const' )
if @l = 0
begin
  ALTER TABLE const ADD status_nlg tinyint NULL
end
go

update const set status_nlg=
  case when fl_high_qual='1' then 3 else
      case when (select flag_rezident from constik where pers_id=const.pers_id)='1' then 2 else 1 end 
  end 
where status_nlg is null
go

if not exists(select 1 from syscolumns where id = object_id('soc_pers_settings') and name = 'month_restart_pf')
begin
   alter table soc_pers_settings add month_restart_pf tinyint null
end
go
if not exists(select 1 from syscolumns where id = object_id('soc_pers_settings') and name = 'month_restart_fms')
begin
   alter table soc_pers_settings add month_restart_fms tinyint null
end
go
update soc_pers_settings set month_restart_fms=month_restart
where month_restart_fms is null and month_restart is not null
go

delete from forms where key_f='ndfl_6'
go

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'skidka_ndfl' 
    and id = ( select id from sysobjects where name = 'arhiv_const' )
if @l = 0
begin
  ALTER TABLE arhiv_const ADD skidka_ndfl decimal(15,2) NULL
end
go

update arhiv_const set skidka_ndfl=isnull(
     (select sum(summa_skidki) from arhiv_skidki where pers_id=arhiv_const.pers_id
        and yy=arhiv_const.yy and mm=arhiv_const.mm
        and id_scale=arhiv_const.n_scala
     )
  ,0)
where skidka_ndfl is null
go

update tbl_esn_codes set yy_end=2014
where code_nalog='7'
go
--drop table ndfl6_head
if not exists (select 1 from sysobjects where name = 'ndfl6_head')
create table ndfl6_head (
  key_f varchar(15) not null primary key,
  kod_ul varchar(15) null,
  otch_year int null,
  otch_per tinyint null,
  date_ datetime null,
  n_korr varchar(3) null,
  kod_no varchar(4) null,
  po_mestu varchar(3) null,
  oktmo varchar(15) null,
  tlf varchar(100) null,
  name_pred varchar(255) null,
  inn varchar(15) null,
  kpp varchar(9) null,
  pr_podp char(1) null,
  fam_podp varchar(50) null,
  im_podp varchar(50) null,
  ot_podp varchar(50) null,
  name_org varchar(255) null,
  name_doc varchar(255) null,
  kol_fizlic int null,
  ud_nal decimal(16,2) null,
  neud_nal decimal(16,2) null,
  vozvr_nal decimal(16,2) null,
  end_mm tinyint null,
  is_oktmo char(1) null,
  is_date_udernal char(1) null 
)
go
grant insert, select, update, delete on ndfl6_head to AitUsers
go

if not exists (select 1 from sysobjects where name = 'ndfl6_scales')
create table ndfl6_scales (
  key_head varchar(15) not null,
  prc tinyint not null,
  doh_all decimal(16,2) null,
  doh_div decimal(16,2) null,
  vich_all decimal(16,2) null,
  nal_all decimal(16,2) null,
  nal_av decimal(16,2) null,
  nal_div decimal(16,2) null,
  primary key(key_head, prc)
)
go
grant insert, select, update, delete on ndfl6_scales to AitUsers
go

if not exists (select 1 from sysobjects where name = 'ndfl6_r2')
create table ndfl6_r2 (
  key_f varchar(15) not null primary key,
  key_head varchar(15) not null,
  date_doh datetime null,
  date_uder datetime null,
  date_perech datetime null,
  sum_doh decimal(16,2) null,
  sum_nal decimal(16,2) null
)
go
grant insert, select, update, delete on ndfl6_r2 to AitUsers
go
if not exists(select 1 from max_ids where table_name='ndfl6_r2')
  insert max_ids(table_name, max_id)
  values ('ndfl6_r2',1) 
go

if not exists(select 1 from syscolumns where id = object_id('vedom_header') and name = 'date_poluch_doh')
begin
   alter table vedom_header add date_poluch_doh datetime null
end
go
if not exists(select 1 from syscolumns where id = object_id('vedom_header') and name = 'date_uder_nal')
begin
   alter table vedom_header add date_uder_nal datetime null
end
go
if not exists(select 1 from syscolumns where id = object_id('vedom_header') and name = 'srok_perech_nal')
begin
   alter table vedom_header add srok_perech_nal datetime null
end
go

if not exists(select 1 from syscolumns where id = object_id('arhiv_const') and name = 'podr_ras')
begin
   alter table arhiv_const add podr_ras varchar(15) null
end
go

update arhiv_const set podr_ras=(
  select top 1 podr_mes from arhiv_ras
  where pers_id=arhiv_const.pers_id and ras_yy=arhiv_const.yy and ras_mm=arhiv_const.mm
)
where podr_ras is null
go

update cfg_reg_params set 
   type_f='sl',
   name_f=' .. (0-., 1-, 2-)'
where app_id=1 and mode_id='reestr_ndfl' and param_id= 'arh_only'
go

update vedom_header
set date_create=convert(datetime,convert(varchar, date_create, 112))
where convert(varchar,date_create,114)<>'00:00:00:000'
go

if exists (select * from forms where key_f='fss_2016xls')
	delete from forms where key_f = 'fss_2016xls'
go
if exists (select * from forms where key_f='fss_2016xml')
	delete from forms where key_f = 'fss_2016xml'
go

if not exists (select * from forms where key_f='fss_2016xls')
      insert into forms (key_f, nomer, name, tip, dot_name, file_, fl_excel, tip_file, fl_arh)
      values ('fss_2016xls', '1', ' 2016', '', 'FSS_2016.xls', 'FSS_2016.rep', NULL, 3, NULL)
go

if not exists (select * from forms where key_f='fss_2017xls')
      insert into forms (key_f, nomer, name, tip, dot_name, file_, fl_excel, tip_file, fl_arh)
      values ('fss_2017xls', '1', ' 2017', '', 'FSS_2017.xls', 'FSS_2017.rep', NULL, 3, NULL)
go

if not exists (select * from forms where key_f='fss_2016xml')
      insert into forms (key_f, nomer, name, tip, dot_name, file_, fl_excel, tip_file, fl_arh, num_str_on_list)
      values ('fss_2016xml', '1', ' 2016', '', NULL, 'FSS_2016_xml.rep', NULL, 1, NULL, 60)
go

update xcheck set oktmo=null
where rtrim(oktmo)=''
update xcheck set code_case=null
where rtrim(code_case)=''
go

if not exists(select 1 from syscolumns where id = object_id('ndfl6_head') and name = 'is_date_udernal')
begin
   alter table ndfl6_head add is_date_udernal char(1) null 
end
go
if not exists(select 1 from syscolumns where id = object_id('ndfl6_head') and name = 'n_file')
begin
   alter table ndfl6_head add n_file varchar(36) null
end
go

if not exists(select 1 from syscolumns where id = object_id('vedom_header') and name = 'summa_uder')
begin
   alter table vedom_header add summa_uder decimal(16,2) null
end
go
if not exists(select 1 from syscolumns where id = object_id('vedom_header') and name = 'okato')
begin
   alter table vedom_header add okato varchar(30) null
end
go
if not exists(select 1 from syscolumns where id = object_id('vedom_header') and name = 'kpp')
begin
   alter table vedom_header add kpp varchar(9) null
end
go
if not exists(select 1 from syscolumns where id = object_id('vedom_header') and name = 'fond')
begin
   alter table vedom_header add fond varchar(32) null
end
go

if not exists(select 1 from syscolumns where id = object_id('vedom_detail') and name = 'summa_uder')
begin
   alter table vedom_detail add summa_uder decimal(16,2) null
end
go


if not exists(select 1 from syscolumns where id = object_id('vedom_header') and name = 'summa_doh')
begin
   alter table vedom_header add summa_doh decimal(16,2) null
end
go
if not exists(select 1 from syscolumns where id = object_id('vedom_detail') and name = 'summa_doh')
begin
   alter table vedom_detail add summa_doh decimal(16,2) null
end
go

--update vedom_detail set summa_doh=null
--update vedom_header set summa_doh=null

update vedom_detail set summa_doh=isnull(summa,0)+isnull(summa_uder,0)
where summa_doh is null 
  and key_header in (select key_f from vedom_header where fl_ndfl='1' and code_r<'700')
go
update vedom_header set summa_doh=isnull(summa,0)+isnull(summa_uder,0)
where summa_doh is null and fl_ndfl='1' and code_r<'700'
go

if exists(select 1 from vedom_header where fl_ndfl='1' and summa_doh is null)
begin
  create table #tmp(
     kf varchar(15) not null,
     pid varchar(15) not null,
     doh decimal(16,2) null,
     nal decimal(16,2) null,
     rmm tinyint null,
     ryy smallint null,
     doc varchar(15) null,
     prc_ tinyint null,
     tip tinyint null,
     kf_head varchar(15) null 
  )

--   35%
  create table #doh_35(
    vid_ varchar(4) null
  )

  insert #doh_35(vid_)
  select code from sp_vid_dohods
  where id_year='2' 
    and id_scale in (
      select id_scale from table_nalog
      where yy=2016 and procent=35
  )

  insert #tmp(kf,kf_head,pid,nal,rmm,ryy,tip,doc, prc_)
  select key_f, key_header, pers_id, summa, ras_mm, ras_yy,1,
    (select isnull(doc_keyf,'') from vedom_header where key_f=vedom_detail.key_header),
    (select prc_ndfl from vedom_header where key_f=vedom_detail.key_header)
  from vedom_detail
  where ras_yy>=2015 and summa_doh is null
    and key_header in (
      select key_f from vedom_header where fl_ndfl='1' and code_r>'700'  
  ) 

  update #tmp set tip=2
  where kf in (
    select max(kf) from #tmp
    group by pid,rmm,ryy,doc,prc_ 
  )

-- 
  update #tmp set doh=isnull((
    select sum(summa)
    from arhiv_ras 
    where ras_yy=#tmp.ryy and ras_mm = #tmp.rmm and pers_id=#tmp.pid
      and case when exists(select 1 from vedom_header where doc_keyf=plat and fl_ndfl='1') 
         then isnull(plat,'') else '' --     -    
      end = doc
      and code<'500' and vid_dohods>'' 
      and vid_dohods not in (select vid_ from #doh_35)
  ),0)
  where prc_<>35 

  update #tmp set doh=isnull((
    select sum(summa)
    from arhiv_ras 
    where ras_yy=#tmp.ryy and ras_mm = #tmp.rmm and pers_id=#tmp.pid
      and isnull(plat,'')=doc
      and code<'500'  
      and vid_dohods in (select vid_ from #doh_35)
  ),0)
  where prc_=35 

-- 
  update #tmp set doh=doh - isnull((
    select sum(summa_doh) from vedom_detail
    where pers_id=#tmp.pid and ras_mm=#tmp.rmm and ras_yy=#tmp.ryy
      and key_header in (select key_f from vedom_header where fl_ndfl='1' and code_r<'700')
  ),0)
  where tip=2 and prc_ in (13,30)
    and doc='' 

--   
  update #tmp set doh=round(
          (select doh from #tmp t1
            where t1.tip=2 and t1.rmm=#tmp.rmm and t1.ryy=#tmp.ryy and t1.doc=#tmp.doc
              and t1.prc_=#tmp.prc_ and t1.pid=#tmp.pid
           )/
          (select sum(nal) from #tmp t2 
            where t2.rmm=#tmp.rmm and t2.ryy=#tmp.ryy and t2.doc=#tmp.doc
              and t2.prc_=#tmp.prc_ and t2.pid=#tmp.pid
           )*
         nal, 2)
  where tip=1

  update #tmp set doh = doh - isnull((
     select sum(doh) from #tmp t1
     where t1.tip=1 and t1.rmm=#tmp.rmm and t1.ryy=#tmp.ryy and t1.doc=#tmp.doc
       and t1.prc_=#tmp.prc_ and t1.pid=#tmp.pid
  ),0)
  where tip=2


--   
  update vedom_detail set summa_doh=doh
  from #tmp
  where key_f=kf

  update vedom_header set summa_doh=isnull((
      select sum(summa_doh) from vedom_detail
      where key_header=vedom_header.key_f
  ),0)
  where key_f in (select kf_head from #tmp)

  drop table #tmp
  drop table #doh_35
end
go

--   8.0.12,    .
if not exists (select * from forms where key_f='NDFL2_15_allo')
	insert into forms (key_f, nomer, name, tip, dot_name, file_, fl_excel, tip_file, fl_arh)
	values ('NDFL2_15_allo', '72', '-2 20151030  ', '', '', 'NDFL_2_20151030_0ktmokpp', '1', 3, NULL)
go

if not exists(select 1 from syscolumns where id = object_id('otchet') and name = 'fl_konst1')
begin
   alter table otchet add fl_konst1 char(1) null
end
go
if not exists(select 1 from syscolumns where id = object_id('otchet') and name = 'fl_konst2')
begin
   alter table otchet add fl_konst2 char(1) null
end
go
if not exists(select 1 from syscolumns where id = object_id('otchet') and name = 'fl_konst3')
begin
   alter table otchet add fl_konst3 char(1) null
end
go
if not exists(select 1 from syscolumns where id = object_id('otchet') and name = 'fl_konst4')
begin
   alter table otchet add fl_konst4 char(1) null
end
go
if not exists(select 1 from syscolumns where id = object_id('otchet') and name = 'fl_konst5')
begin
   alter table otchet add fl_konst5 char(1) null
end
go
if not exists(select 1 from syscolumns where id = object_id('otchet') and name = 'fl_konst6')
begin
   alter table otchet add fl_konst6 char(1) null
end
go
if not exists(select 1 from syscolumns where id = object_id('otchet') and name = 'fl_konst7')
begin
   alter table otchet add fl_konst7 char(1) null
end
go
if not exists(select 1 from syscolumns where id = object_id('otchet') and name = 'fl_konst8')
begin
   alter table otchet add fl_konst8 char(1) null
end
go
if not exists(select 1 from syscolumns where id = object_id('otchet') and name = 'app_id')
begin
   alter table otchet add app_id tinyint null
end
go
update otchet set app_id=2 where app_id is null
go


if not exists(select 1 from syscolumns where id = object_id('constn') and name = 'patent_used')
begin
   alter table constn add patent_used int null
end
go
update constn set patent_used=isnull((
    select nalog - uder from arhiv_const
    where nalog_local>0 and mm=constn.mm and yy=constn.yy
      and pers_id=constn.pers_id_2
  ),0)
where patent_used is null
go

if not exists(select 1 from sp_free_tables where kod='nall')
  insert sp_free_tables(kod, name, brief_name)
  values ('nall','','')
go
if not exists(select 1 from sp_free_tables where kod='perech')
  insert sp_free_tables(kod, name, brief_name)
  values ('perech','','')
go

if not exists(select 1 from syscolumns where id = object_id('ust') and name = 'fl_otp_av')
begin
   alter table ust add fl_otp_av int null
end
go
if not exists(select 1 from syscolumns where id = object_id('sprav') and name = 'code_av')
begin
   alter table sprav add code_av char(3) null
end
go
if not exists(select 1 from syscolumns where id = object_id('sprav') and name = 'code_av_next')
begin
   alter table sprav add code_av_next char(3) null
end
go

if not exists(select 1 from syscolumns where id = object_id('documents') and name = 'fl_next_month')
begin
   alter table documents add fl_next_month char(1) null
end
go

if object_id('vari_other') is null 
begin
  select top 0 * into vari_other 
  from vari
  
  alter table vari_other add primary key (key_field) 
end
go

if not exists(select 1 from syscolumns where id = object_id('sp_vid_lgots') and name = 'ochered')
begin
   alter table sp_vid_lgots add ochered smallint null
end
go

grant insert, select, update, delete on vari_other to AitUsers
go

if not exists(select 1 from sprav where code='750')
  insert sprav(code, codename, vid, fl_sum_up)
  values('750','  ','00','1')
go
if not exists(select 1 from sprav where code='850')
  insert sprav(code, codename, vid, fl_sum_up)
  values('850','   ','00','1')
go

update vari set prc=(
  select max(procent) from table_nalog where yy=2017
    and id_scale=(select id_scale from sprav where code=vari.code)
)
where code between '772' and '785'
  and code<>'780' and code <>'781' and isnull(prc,0) not in (9,13,15,30,35) 
go

update vari set prc=(
  select max(procent) from table_nalog where yy=2017
    and id_scale=(select n_scala from const where pers_id=vari.pers_id)
)
where (code='780' or code ='781') and isnull(prc,0) not in (9,13,15,30,35) 
go

update arhiv_ras set prc=(
  select max(procent) from table_nalog where yy=arhiv_ras.ras_yy
    and id_scale=(select id_scale from sprav where code=arhiv_ras.code)
)
where ras_yy in (2016,2017) and code between '772' and '785'
  and code<>'780' and code <>'781' and isnull(prc,0) not in (9,13,15,30,35) 
go
update arhiv_ras_fond set prc=(
  select max(procent) from table_nalog where yy=arhiv_ras_fond.ras_yy
    and id_scale=(select id_scale from sprav where code=arhiv_ras_fond.code)
)
where ras_yy in (2016,2017) and code between '772' and '785'
  and code<>'780' and code <>'781' and isnull(prc,0) not in (9,13,15,30,35) 
go

update arhiv_ras set prc=(
  select max(procent) from table_nalog where yy=arhiv_ras.ras_yy
    and id_scale=(select n_scala from arhiv_const 
                  where pers_id=arhiv_ras.pers_id and mm=arhiv_ras.ras_mm and yy=arhiv_ras.ras_yy)
)
where ras_yy in (2016,2017) and (code='780' or code ='781') and isnull(prc,0) not in (9,13,15,30,35) 
go
update arhiv_ras_fond set prc=(
  select max(procent) from table_nalog where yy=arhiv_ras_fond.ras_yy
    and id_scale=(select n_scala from arhiv_const 
                  where pers_id=arhiv_ras_fond.pers_id and mm=arhiv_ras_fond.ras_mm and yy=arhiv_ras_fond.ras_yy)
)
where ras_yy in (2016,2017) and (code='780' or code ='781') and isnull(prc,0) not in (9,13,15,30,35) 
go

if not exists(select 1 from syscolumns where id = object_id('ust_nlg') and name = 'fam_upoln')
begin
   alter table ust_nlg add fam_upoln varchar(40) null
end
go
if not exists(select 1 from syscolumns where id = object_id('ust_nlg') and name = 'imya_upoln')
begin
   alter table ust_nlg add imya_upoln varchar(40) null
end
go
if not exists(select 1 from syscolumns where id = object_id('ust_nlg') and name = 'otch_upoln')
begin
   alter table ust_nlg add otch_upoln varchar(40) null
end
go
if not exists(select 1 from syscolumns where id = object_id('ust_nlg') and name = 'doc_upoln')
begin
   alter table ust_nlg add doc_upoln varchar(100) null
end
go
if not exists(select 1 from syscolumns where id = object_id('ust_nlg') and name = 'podpisant')
begin
   alter table ust_nlg add podpisant char(1) null
end
go
update ust_nlg set podpisant='1' where podpisant is null
go
declare @rasl varchar(20)
select @rasl=n_raslist from ust_nlg where key_f='1'
if len(rtrim(@rasl))<18
  update ust_nlg set n_raslist = rtrim(@rasl)+ left(@rasl,1)+ '11'
  where key_f='1'
go

if not exists(select 1 from syscolumns where id = object_id('sp_vid_lgots') and name = 'yy_begin')
begin
   alter table sp_vid_lgots add yy_begin smallint null
end
go
if not exists(select 1 from syscolumns where id = object_id('sp_vid_lgots') and name = 'yy_end')
begin
   alter table sp_vid_lgots add yy_end smallint null
end
go

if not exists(select 1 from sysobjects where name = 'fltr_nach_head')
  create table fltr_nach_head(
    key_f varchar(15) not null primary key,
    name_ varchar(50) null
  )
go
grant select,insert,update,delete on fltr_nach_head to AitUsers
go
if not exists(select 1 from sysobjects where name = 'fltr_nach')
  create table fltr_nach(
    key_f varchar(15) not null primary key,
    key_head varchar(15) not null,
    field varchar(50) null,
    cond varchar(2) null,
    expr varchar(255) null,
    br_in char(1) null,
    br_out char(1) null,
    n_row int not null identity(1,1),
    logic varchar(3) null
  )
go
grant select,insert,update,delete on fltr_nach to AitUsers
go

if not exists(select 1 from syscolumns where id = object_id('sprav') and name = 'tip_esss')
begin
   alter table sprav add tip_esss char(2) null
end
go
update sprav set tip_esss='-'
where tip_esss is null
  and charindex(code, (select max(iskl_codes) from ust_rsv))>0
go
update sprav set tip_esss='fb'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{_}')
      )>0
go
update sprav set tip_esss='fd'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{__}')
      )>0
go
update sprav set tip_esss='f1'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{_1}')
      )>0
go
update sprav set tip_esss='f2'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{_2}')
      )>0
go
update sprav set tip_esss='fp'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{}')
      )>0
go
update sprav set tip_esss='fi'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{_}')
      )>0
go
update sprav set tip_esss='fr'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{}')
      )>0
go
update sprav set tip_esss='fe'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{__}')
      )>0
go
update sprav set tip_esss='fn'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{__}')
      )>0
go
update sprav set tip_esss='fz'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{_}')
      )>0
go

update sprav set tip_esss='cb'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{__}')
      )>0
go
update sprav set tip_esss='cd'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{___}')
      )>0
go
update sprav set tip_esss='c1'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{__1_}')
      )>0
go
update sprav set tip_esss='c2'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{__2_}')
      )>0
go

update sprav set tip_esss='mb'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{__}')
      )>0
go
update sprav set tip_esss='md'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{___}')
      )>0
go
update sprav set tip_esss='m1'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{__1_}')
      )>0
go
update sprav set tip_esss='m2'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{__2_}')
      )>0
go

update sprav set tip_esss='pb'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{.__}')
      )>0
go

update sprav set tip_esss='rb'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{..__}')
      )>0
go
update sprav set tip_esss='rd'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{..___}')
      )>0
go
update sprav set tip_esss='r1'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{..__1_}')
      )>0
go
update sprav set tip_esss='r2'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{..__2_}')
      )>0
go

update sprav set tip_esss='sb'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{._255-__}')
      )>0
go
update sprav set tip_esss='sd'
where tip_esss is null
  and charindex(code, (select max(value_) from nt_l_keywords 
                       where keyword_='{._255-___}')
      )>0
go

update sprav set tip_esss='dg'
where code in (select kod from pf_nastr_podbor where otp_bl = 7 and app = 3)
go

update sprav set tip_esss=''
where tip_esss is null
go

alter table vari alter column num_prikaz varchar(100)
alter table ras alter column num_prikaz varchar(100)
alter table arhiv_ras alter column num_prikaz varchar(100)
alter table ras_1 alter column num_prikaz varchar(100)
alter table arhiv_ras_fond alter column num_prikaz varchar(100)
go

if not exists(select 1 from syscolumns where id = object_id('ust') and name = 'fl_prof_doc')
begin
   alter table ust add fl_prof_doc char(1) null
end
go

update filtr_data set sprav=''
where table_name='vari' and col_name='plat'
go

--     
select * into #tmp_sprav from sprav where code in ('710','711','712','715')

update #tmp_sprav set code=convert(char(3),convert(int,code)+10),
                      codename=rtrim(codename)+' //' 
insert into sprav select * from #tmp_sprav
where code not in (select code from sprav)

drop table #tmp_sprav
go

update brvr set h=round(h,2)
go

if not exists (select * from forms where key_f='REG_NDFL_2017')
	insert into forms (key_f, nomer, name, tip, dot_name, file_, fl_excel, tip_file, fl_arh)
	values ('REG_NDFL_2017', '1', '   2017', '', '', 'reg_ndfl', '1', 3, NULL)
go

if not exists(select 1 from syscolumns where id = object_id('ust_rsv') and name = 'vozm_fss_mm1')
begin
   alter table ust_rsv add vozm_fss_mm1 decimal(16,2) null
end
go
if not exists(select 1 from syscolumns where id = object_id('ust_rsv') and name = 'vozm_fss_mm2')
begin
   alter table ust_rsv add vozm_fss_mm2 decimal(16,2) null
end
go
if not exists(select 1 from syscolumns where id = object_id('ust_rsv') and name = 'vozm_fss_mm3')
begin
   alter table ust_rsv add vozm_fss_mm3 decimal(16,2) null
end
go

/*    */
set QUOTED_IDENTIFIER off
go

set ARITHABORT off
go

UPDATE  ust  Set  version = '8.15', zp_patch='8.15.1'
  where  key_f = '1'
GO

SELECT 'DataBase now is upgraded to version ' + version FROM ust WHERE key_f = '1'
GO
